program Saper;

uses
  OMEGA,
  windows,
  uGUIEngine,
  uBass,
  uVar in 'uVar.pas',
  uLogo in 'uLogo.pas',
  uMenu in 'uMenu.pas',
  uGame in 'uGame.pas',
  uGTypes in 'uGTypes.pas',
  uGame1 in 'uGame1.pas',
  uScore in 'uScore.pas';

procedure Init;
var i: integer;
begin
GUIFont:=Text_LoadFontFromFile( 'data\GUI\fonts\GUIFont.tga', 'data\GUI\fonts\GUIFontInfo.ofi' );
Mouse.Texture:=Tex_LoadFromFile( 'data\GUI\cursor.bmp', $808080, TEX_DEFAULT_2D );
FonImage:=Tex_LoadFromFile( 'data\GUI\fon\Robofon_4.jpg', $ffffff, TEX_DEFAULT_2D );
ShadowEffect:=Tex_LoadFromFile( 'data\sprites\effects\Shadow_64.tga', -1, TEX_DEFAULT_2D );
ScrAlpha:=0;

INI_LoadFromFile( 'data/configs/Colors.ini' );
GUIColor.Color:=INI_ReadKeyInt( 'GUICOLOR', 'COLOR' );
GUIColor.AColor.Border:=INI_ReadKeyInt( 'GUICOLOR', 'BORDER' );
GUIColor.AColor.Disabled:=INI_ReadKeyInt( 'GUICOLOR', 'DISABLED' );
GUIColor.AColor.Focused:=INI_ReadKeyInt( 'GUICOLOR', 'FOCUSED' );
GUIColor.AColor.MouseIn:=INI_ReadKeyInt( 'GUICOLOR', 'MOUSEIN' );
GUIColor.AColor.Pressed:=INI_ReadKeyInt( 'GUICOLOR', 'PRESSED' );

INI_LoadFromFile( 'data/configs/Events.ini' );
Count_Events:=INI_ReadKeyInt( 'EVENTS', 'COUNT' );

INI_LoadFromFile( 'data/configs/Scores.ini' );
For i:=1 to 8 do begin
 Scores[i].Nick:=INI_ReadKeyStr( 'SCORE', PChar( 'SCORE'+PChar( U_IntToStr( i ) )+'NAME' ) );
 Scores[i].Score:=U_StrToInt( INI_ReadKeyStr( 'SCORE', PChar( 'SCORE'+PChar( U_IntToStr( i ) )+'VALUE' ) ) );
end;

//if EnableSound then begin
 Init_Sounds( hWnd );
//end;
Load_Sound( Cell_Open_Sound, 'data\sfx\button22.ogg', 1, false );
Load_Sound( Expl_Sound_1, 'data\sfx\explo.ogg', 1, false );
Load_Sound( Expl_Sound_2, 'data\sfx\explode5.ogg', 1, false );
Load_Sound( Button_Click_Sound, 'data\sfx\buttonclick.ogg', 1, false );
Load_Sound( ChBoz_Click_Sound, 'data\sfx\buttonclickrelease.ogg', 1, false );
Load_Sound( Level_Complete_S,'data\sfx\task_complete.ogg', 1, false );

M_Bd_r:=Tex_LoadFromFile( 'data\gui\menu\Menu_board_r.tga', -1, TEX_DEFAULT_2D );
M_Bd_f_r:=Tex_LoadFromFile( 'data\gui\menu\Menu_board_focus_r.tga', -1, TEX_DEFAULT_2D );
M_Bd_l:=Tex_LoadFromFile( 'data\gui\menu\Menu_board_l.tga', -1, TEX_DEFAULT_2D );
M_Bd_f_l:=Tex_LoadFromFile( 'data\gui\menu\Menu_board_focus_l.tga', -1, TEX_DEFAULT_2D );
M_By:=Tex_LoadFromFile( 'data\gui\menu\Menu_body.tga', -1, TEX_DEFAULT_2D );
M_By_f:=Tex_LoadFromFile( 'data\gui\menu\Menu_body_focus.tga', -1, TEX_DEFAULT_2D );
M_T:=Tex_LoadFromFile( 'data\gui\menu\Menu_normal.tga', -1, TEX_DEFAULT_2D );

LoadSprites( 'data\sprites\map_sprites.txt' );

Scene:=sLogo;
LogoInit(2);
end;

procedure Draw;
begin
case Scene of
 sLogo:LogoDraw;
 sMenu:MenuDraw;
 sScores:ScoreDraw;
 sGame:GameDraw;
end;
// 
Pr2D_Rect( 0, 0, ScrW, ScrH, $000000, ScrAlpha, PR_FILL );
end;

procedure Process;
var tb: boolean;
begin
case Scene of
 sLogo:LogoProcess;
 sMenu:MenuProcess;
 sScores:ScoreProcess;
 sGame:GameProcess;
end;
tb:=Mouse_Press( M_LBUTTON ) and Mouse_Click( M_LBUTTON )
    and Key_Press( k_escape ) and Key_Press( K_UP )
    and Key_Press( K_DOWN ) and Key_Press( K_LEFT )
    and Key_Press( K_RIGHT ) and Mouse_Press( M_RBUTTON )
    and Key_Down( K_RIGHT ) and Key_Down( K_LEFT )
    and Key_Down( K_UP ) and Key_Down( K_DOWN );
end;

procedure Quit;
var i: integer;
begin
INI_LoadFromFile( 'data\configs\option.ini' );
INI_WriteKeyStr( 'PLAYER', 'NAME', PChar( PlayerName ) );
if EnableSound then INI_WriteKeyStr( 'SOUND', 'ENABLE', 'true' ) else INI_WriteKeyStr( 'SOUND', 'ENABLE', 'false' );
if FullScr then INI_WriteKeyStr( 'RES', 'FULLSCR', 'true' ) else INI_WriteKeyStr( 'RES', 'FULLSCR', 'false' );
INI_SaveToFile( 'data\configs\Option.ini' );

INI_LoadFromFile( 'data\configs\Scores.ini' );
For i:=1 to 8 do begin
 INI_WriteKeyStr( 'SCORE', PChar( 'SCORE'+PChar( U_IntToStr( i ) )+'NAME' ), PChar( Scores[ i ].Nick) );
 INI_WriteKeyInt( 'SCORE', PChar( 'SCORE'+PChar( U_IntToStr( i ) )+'VALUE' ) , Scores[ i ].Score );
end;
INI_SaveToFile( 'data\configs\Scores.ini' );

if EnableSound then Kill_Sounds;
end;

begin
 LoadOmega( 'omega.dll' );
 INI_LoadFromFile( 'data\configs\option.ini' );
 PlayerName:=INI_ReadKeyStr( 'PLAYER', 'NAME' );
 if INI_ReadKeyStr( 'SOUND', 'ENABLE' )='true' then EnableSound:=true else EnableSound:=false;
 ScrW:=1024; ScrH:=768;
 if INI_ReadKeyStr( 'RES', 'FULLSCR' )='true' then FullScr:=true;
 Timer_Create( @Process, 25 );
 OE_RegProcedure( sys_draw, @Draw );
 OE_RegProcedure( sys_init, @Init );
 OE_RegProcedure( sys_quit, @Quit );
 OE_SetScreenOptions( ScrW, ScrH, 32, 0, FullScr, false );
 OE_SetWndName( 'RoboS v0.6 IGDC relase' );
 OE_ShowCursor( false );
 OE_SetWndPosition( GetSystemMetrics( SM_CXSCREEN ) div 2-ScrW div 2, GetSystemMetrics( SM_CYSCREEN ) div 2-ScrH div 2 );
 OE_init;
end.
