unit uBass;
//  Mefistofel-,      :)
interface

uses Windows, bass;

type                { }
  TSound = record
   Stream:HStream;   { }
   loaded:boolean;   { }
   playing:boolean;  { }
   volume:single;    { }
   time:longint;     {  -  }
  end;

procedure Init_Sounds(hWnd:THandle);
procedure Kill_Sounds();
procedure Load_Sound(Var Sound:TSound;FileName:string;vol:single = 1;loop:boolean = false);
procedure Play_Sound(Var Sound:TSound);
procedure Stop_Sound(Var Sound:TSound);
procedure Pause_Sound(Var Sound:TSound);       
procedure Change_Sound_Volume(var Sound:TSound;Volume:byte);

Var
  sound_frequency : integer = 44100;   {}
  sound_volume : single = 1;           {}

implementation

procedure Init_Sounds(hWnd:THandle);  { }
begin
 if (HIWORD(BASS_GetVersion) <> BASSVERSION) then exit;{  }
 if not BASS_Init(-1, sound_frequency, 0, HWnd, nil) then
  MessageBox(0,'Error','Sound Initial Error',0);  { }
end;

procedure Kill_Sounds();   {}
begin
 BASS_Free();
end;

procedure Change_Sound_Volume(var Sound:TSound;Volume:byte);
begin                {  }
 Sound.volume:=Volume/100;
 BASS_ChannelSetAttribute(Sound.Stream, BASS_ATTRIB_VOL, Sound.volume);
end;

procedure Load_Sound(Var Sound:TSound;FileName:string;vol:single = 1;loop:boolean = false);
begin                { }
 Sound.Stream:= BASS_StreamCreateFile(False, PChar(FileName), 0, 0, 0);   {}
 if loop then BASS_ChannelFlags(Sound.Stream, BASS_SAMPLE_LOOP, BASS_SAMPLE_LOOP);{  -  }
 Sound.volume:=sound_volume*vol;{}
 BASS_ChannelSetAttribute(Sound.Stream, BASS_ATTRIB_VOL, Sound.volume);{}
 BASS_ChannelSetAttribute(Sound.Stream, BASS_ATTRIB_FREQ, sound_frequency);{}
 Sound.loaded:=true;       {}
 Sound.playing:=false;     { }
end;

procedure Play_Sound(Var Sound:TSound);  { }
begin
 If Sound.loaded then      
  If Sound.playing then  {      }
   BASS_ChannelPlay(Sound.Stream, false) else
   BASS_ChannelPlay(Sound.Stream, true); {  -  }
 Sound.playing:=true;
end;

procedure Stop_Sound(Var Sound:TSound);  { }
begin
 If Sound.loaded then
  BASS_ChannelStop(Sound.Stream);
 Sound.playing:=false;
end;

procedure Pause_Sound(Var Sound:TSound);    { }
begin
 If Sound.loaded then
  BASS_ChannelPause(Sound.Stream);
end;

end.
