unit uGame1;

interface

procedure LoadFirstEvent;
procedure LoadNextEvent;
procedure ReloadEvent;
procedure ShowScoreScr;
procedure EndGame;

procedure Game1Init;
procedure Game1Draw;
procedure Game1Process;

implementation

uses OMEGA, uVar, uMenu, uGTypes,
     uGUIEngine, OpenGL, uBass;

var Field:TField;
    StopShadow, UpSA, DownSA, GoToMenu : boolean;
    Paused: boolean;

var GoMenuRect    : oeRect;
    GoMenuFocused : boolean;
    PauseRect     : oeRect;
    PauseFocused  : boolean;
    ReloadRect    : oeRect;
    ReloadFocused : boolean;
    ExitRect      : oeRect;
    ExitFocused   :boolean;

procedure LoadFirstEvent;
var Str:string;
begin
Now_Event:=1;
INI_LoadFromFile( 'data/configs/Events.ini' );
Str:=INI_ReadKeyStr( 'EVENTS', PChar( U_IntToStr( Now_Event ) ) );
Field.LoadField( Str );
Field.Map_X:=ScrW div 2-Field.RoboS.Pos.x*64;
Field.Map_Y:=ScrH div 2+Field.RoboS.Pos.y*64;
Field.ActivateCamera;
end;

procedure LoadNextEvent;
var Str:string;
    i1, i2 :integer;
    tb: boolean;
begin
tb:=false;
For i1:=1 to 7 do
 if PlayerScore>=Scores[ i1 ].Score then begin
  For i2:=8 downto i1+1 do Scores[ i2 ]:=Scores[ i2-1 ];
  Scores[ i1 ].Nick  :=PlayerName;
  Scores[ i1 ].Score :=PlayerScore;
  tb:=true;
  Break;
 end;
If (PlayerScore>=Scores[ 8 ].Score) and not tb then begin
 Scores[ 8 ].Nick  :=PlayerName;
 Scores[ 8 ].Score :=PlayerScore;
end;

Inc( Now_Event );
if Now_Event>Count_Events then begin
 EndGame;
end else begin
 INI_LoadFromFile( 'data/configs/Events.ini' );
 Str:=INI_ReadKeyStr( 'EVENTS', PChar( U_IntToStr( Now_Event ) ) );
 Field.LoadField( Str );
 Field.Map_X:=ScrW div 2-Field.RoboS.Pos.x*64;
 Field.Map_Y:=ScrH div 2+Field.RoboS.Pos.y*64;
 Field.ActivateCamera;
end;
end;

procedure ReloadEvent;
var Str:string;
begin
INI_LoadFromFile( 'data/configs/Events.ini' );
Str:=INI_ReadKeyStr( 'EVENTS', PChar( U_IntToStr( Now_Event ) ) );
Field.LoadField( Str );
Field.ActivateCamera;
end;

procedure ShowScoreScr;
begin
end;

procedure EndGame;
var i1, i2 :integer;
    tb: boolean;
begin
tb:=false;
For i1:=1 to 7 do
 if PlayerScore>=Scores[ i1 ].Score then begin
  For i2:=8 downto i1+1 do Scores[ i2 ]:=Scores[ i2-1 ];
  Scores[ i1 ].Nick  :=PlayerName;
  Scores[ i1 ].Score :=PlayerScore;
  tb:=true;
  Break;
 end;
If (PlayerScore>=Scores[ 8 ].Score) and not tb then begin
 Scores[ 8 ].Nick  :=PlayerName;
 Scores[ 8 ].Score :=PlayerScore;
end;

MenuInit;
Scene:=sMenu;
end;

procedure Game1Init;
begin
Paused:=false;

glClearColor( 0.2627451, 0.2627451, 0.2627451, 1 );

GoMenuRect.X     :=10;  GoMenuRect.Y      :=ScrH-70;
GoMenuRect.Width :=140; GoMenuRect.Height :=70;
GoMenuFocused:=false;
PauseRect.X     :=160;  PauseRect.Y      :=ScrH-70;
PauseRect.Width :=105;  PauseRect.Height :=70;
PauseFocused:=false;
ReloadRect.X     :=275; ReloadRect.Y      :=ScrH-70;
ReloadRect.Width :=220; ReloadRect.Height :=70;
ReloadFocused:=false;
ExitRect.X     :=895; ExitRect.Y      :=ScrH-70;
ExitRect.Width :=119; ExitRect.Height :=70;
ExitFocused:=false;

GoToMenu:=false;
StopShadow:=false;
UpSA:=false;
DownSA:=true;
GUI.Count:=0;

LoadFirstEvent;
end;

procedure Game1Draw;
begin
Field.Camera^.Active:=true;
with Field do begin
 SSprite_Draw( Sprites[13], Map_X-32, Map_Y-32, 64, 64, 255, 270 );
 SSprite_Draw( Sprites[13], Map_X-32, Map_Y-Height*64-32, 64, 64 );
 SSprite_Draw( Sprites[13], Map_X+Weigth*64-32, Map_Y-32, 64, 64, 255, 180 );
 SSprite_Draw( Sprites[13], Map_X+Weigth*64-32, Map_Y-Height*64-32, 64, 64, 255, 90 );

 SSprite_Draw( Sprites[14], Map_X+32, Map_Y-Height*64+32, Weigth*64-64, Height*64-64 );
 SSprite_Draw( Sprites[16], Map_X-32, Map_Y-Height*64+32, 64, Height*64-64 );
 SSprite_Draw( Sprites[16], Map_X+Weigth*64-32, Map_Y-Height*64+32, 64, Height*64-64, 255, 180 );
 SSprite_Draw( Sprites[17], Map_X+32, Map_Y-Height*64-32, Weigth*64-64, 64, 255, 0 );
 SSprite_Draw( Sprites[17], Map_X+32, Map_Y-32, Weigth*64-64, 64, 255, 180 );
end;
if not Paused then Field.Draw;
Field.Camera^.Active:=false;

if GoMenuFocused or PauseFocused or ReloadFocused or ExitFocused then begin
 if GoMenuFocused then begin
  SSprite_Draw( M_Bd_r, ScrW-64, ScrH-128, 64, 128 );
  SSprite_Draw( M_Bd_f_l, 0, ScrH-128, 64, 128 );
  SSprite_Draw( M_By_f, 64, ScrH-128, 86, 128 );
  SSprite_Draw( M_By, 150, ScrH-128, ScrW-212, 128 );
 end;
 if PauseFocused then begin
  SSprite_Draw( M_Bd_r, ScrW-64, ScrH-128, 64, 128 );
  SSprite_Draw( M_Bd_l, 0, ScrH-128, 64, 128 );
  SSprite_Draw( M_By, 64, ScrH-128, 96, 128 );
  SSprite_Draw( M_By_f, 160, ScrH-128, 105, 128 );
  SSprite_Draw( M_By, 265, ScrH-128, ScrW-307, 128 );
 end;
 if ReloadFocused then begin
  SSprite_Draw( M_Bd_r, ScrW-64, ScrH-128, 64, 128 );
  SSprite_Draw( M_Bd_l, 0, ScrH-128, 64, 128 );
  SSprite_Draw( M_By, 64, ScrH-128, 211, 128 );
  SSprite_Draw( M_By_f, 275, ScrH-128, 220, 128 );
  SSprite_Draw( M_By, 495, ScrH-128, ScrW-558, 128 );
 end;
 if ExitFocused then begin
  SSprite_Draw( M_Bd_f_r, ScrW-64, ScrH-128, 64, 128 );
  SSprite_Draw( M_Bd_l, 0, ScrH-128, 64, 128 );
  SSprite_Draw( M_By_f, 895, ScrH-128, 65, 128 );
  SSprite_Draw( M_By, 64, ScrH-128, ScrW-193, 128 );
 end;
end else begin
 SSprite_Draw( M_Bd_r, ScrW-64, ScrH-128, 64, 128 );
 SSprite_Draw( M_Bd_l, 0, ScrH-128, 64, 128 );
 SSprite_Draw( M_By, 64, ScrH-128, ScrW-128, 128 );
end;

SSprite_Draw( M_T, 0, ScrH-64, ScrW, 64 );

if not Field.RoboS.Timer<=0 then Text_Draw( GUIFont, 515, ScrH-50, U_IntToStr( Field.RoboS.Timer ), 1, 0, 255, $000000 );
PR2D_RECT( 580, ScrH-50, 280, 30, $000000 );
if Field.RoboS.Timer>0 then PR2D_RECT( 580, ScrH-50, 280*(Field.RoboS.Timer/Field.RoboS.MaxTime), 30, $717171, 200, PR_FILL );

if Paused then begin
 PR2D_RECT( ScrW/2-Text_GetWidth( GUIFont, '', 1, 0 )/2-30, ScrH/2-70,
            Text_GetWidth( GUIFont, '', 1, 0 )+60, 80, $000000, 180, PR_FILL );
 Text_Draw( GUIFont, ScrW/2-Text_GetWidth( GUIFont, '', 1, 0 )/2 ,
            ScrH/2-40, '', 1, 0, 255, $ffffff );
end;


GUI.Draw;
end;

procedure Game1Process;
begin

if UpSA then begin
 if ScrAlpha<=247 then Inc( ScrAlpha, 7 )
  else begin
   ScrAlpha:=255;
   UpSA:=false;
   DownSA:=true;
   if GoToMenu then begin
    Field.Camera^.Active:=false;
    MenuInit;
    Scene:=sMenu;
   end else
    if Field.Success then begin
     PlayerScore:=PlayerScore+Field.LevelScore;
     LoadNextEvent;
    end else begin
     ReloadEvent;
     PlayerScore:=PlayerScore+Field.LevelScore;
     if PlayerScore<0 then PlayerScore:=0;     
    end;
  end;
end;

if DownSA then begin
 Dec( ScrAlpha, 5 );
 if ScrAlpha<6 then begin
  ScrAlpha:=0;
  StopShadow:=true;
  DownSA:=false;
 end;
end;

GUI.Process;

if Key_Press( k_escape ) then begin
 Field.Camera^.Active:=false;
 MenuInit;
 Scene:=sMenu;
end;

If Col_PointInAABB( Mouse_X, Mouse_Y, @GoMenuRect ) then GoMenuFocused:=true
 else GoMenuFocused:=false;
If Col_PointInAABB( Mouse_X, Mouse_Y, @PauseRect ) then PauseFocused:=true
 else PauseFocused:=false;
If Col_PointInAABB( Mouse_X, Mouse_Y, @ReloadRect ) then ReloadFocused:=true
 else ReloadFocused:=false;
If Col_PointInAABB( Mouse_X, Mouse_Y, @ExitRect ) then ExitFocused:=true
 else ExitFocused:=false;

if Mouse_Click( M_LBUTTON ) then begin
 if GoMenuFocused then begin
  if EnableSound then Play_Sound( Button_Click_Sound ); ////
  UpSA:=true;
  DownSA:=false;
  StopShadow:=true;
  GoToMenu:=true;
 end;
 if PauseFocused then begin
  if EnableSound then Play_Sound( Button_Click_Sound ); ////
  Paused:=not Paused;
 end;
 if ReloadFocused then begin
  if EnableSound then Play_Sound( Button_Click_Sound ); /////
  UpSA:=true;
  DownSA:=false;
  StopShadow:=false;
  Field.Success:=false;
 end;
 if ExitFocused then begin
  OE_Quit;
 end;
end;

if StopShadow and not Paused then begin
 Field.Process;
 if Field.Complete then begin
  UpSA:=true;
  DownSA:=false;
  ScrAlpha:=0;
  StopShadow:=false;
 end;
end;

end;

end.
