unit uMenu;

interface

procedure MenuInit;
procedure MenuDraw;
procedure MenuProcess;

implementation

uses OMEGA, uGUIEngine,
     uVar, uBass, uScore,
     Windows, uGame;

var EditId, LabelId, ChB1Id, ChB2Id: integer;
    MenuFonH1, MenuFonH2: integer;
    MenuFon1, MenuFon2: oeRect;

    GoToGame  : boolean;
    GoToScore : boolean;

procedure GoGame;
begin
if EnableSound then  Play_Sound( Button_Click_Sound );
GoToGame:=true;
end;

procedure GoScore;
begin
if EnableSound then Play_Sound( ChBoz_Click_Sound );
GoToScore:=true;
end;

procedure SetFullScr( Checked : Boolean; Sender, Parent : CGUIElement );
begin
if EnableSound then Play_Sound( ChBoz_Click_Sound );
FullScr:=Checked;
OE_ChangeScreenOptions(ScrW,ScrH,32,0,Checked,FALSE );
if not Checked then OE_SetWndPosition(GetSystemMetrics(SM_CXSCREEN) div 2-ScrW div 2,GetSystemMetrics(SM_CYSCREEN) div 2-ScrH div 2);
end;

procedure DisableSound( Checked : Boolean; Sender, Parent : CGUIElement );
begin
if EnableSound then Play_Sound( ChBoz_Click_Sound );
EnableSound:=not Checked;
//if Checked then Kill_Sounds else Init_Sounds(hWnd);
end;

procedure MenuInit;
var id:integer;
begin
GoToGame:=false;
GoToScore:=false;

MenuFonH2:=20;
MenuFon2.X:=ScrW div 2-trunc(Text_GetWidth(GUIFont,' ',1,0)) div 2-51;
MenuFon2.Y:=ScrH-20;
MenuFon2.Width:=Text_GetWidth(GUIFont,' ',1,0)+102;
MenuFon2.Height:=20;

MenuFonH1:=20;
MenuFon1.X:=ScrW div 2-trunc(MenuFon2.Width/2);
MenuFon1.Y:=-1;
MenuFon1.Width:=MenuFon2.Width;
MenuFon1.Height:=20;

GUI.Count:=0;

id:=GUI.AddElement(CreateButton(nil,nil,GUIFont,' ',
                                trunc(ScrW/2-(Text_GetWidth(GUIFont,' ',1,0)/2+10)),
                                trunc(ScrH/2-60)-60,Text_GetWidth(GUIFont,' ',1,0)+20,40,@GoGame));
(GUI.List[id] as CGUIButton).Color:=GUIColor.Color;
(GUI.List[id] as CGUIButton).AColor:=GUIColor.AColor;

id:=GUI.AddElement(CreateButton(nil,nil,GUIFont,'',
                                trunc(ScrW/2-(Text_GetWidth(GUIFont,'',1,0)/2+10)),
                                trunc(ScrH/2-60),Text_GetWidth(GUIFont,'',1,0)+20,40,@GoScore));
(GUI.List[id] as CGUIButton).Color:=GUIColor.Color;
(GUI.List[id] as CGUIButton).AColor:=GUIColor.AColor;

id:=GUI.AddElement(CreateButton(nil,nil,GUIFont,'',
                                trunc(ScrW/2-(Text_GetWidth(GUIFont,'',1,0)/2+10)),
                                trunc(ScrH/2-60)+100,Text_GetWidth(GUIFont,'',1,0)+20,40,@OE_Quit));
(GUI.List[id] as CGUIButton).Color:=GUIColor.Color;
(GUI.List[id] as CGUIButton).AColor:=GUIColor.AColor;

id:=GUI.AddElement(CreateLabel(nil,GUIFont,ScrW div 2-trunc(Text_GetWidth(GUIFont,PChar(' :'),1,0)) div 2,-85,' :'));
LabelId:=id;
id:=GUI.AddElement(CreateEdit(nil,nil,GUIFont,ScrW div 2-trunc(Text_GetWidth(GUIFont,PChar(PlayerName),1,0)) div 2,
                                              -50,Text_GetWidth(GUIFont,PChar(PlayerName),1,0)+5,40,PlayerName));
(GUI.List[id] as CGUIEdit).Max:=10;
(GUI.List[id] as CGUIEdit).Font.Color:=$000000;
EditId:=id;

id := GUI.AddElement(CreateCheckBox(nil,nil,GUIFont,MenuFon2.X+30,ScrH+20,16,16,'  ',FullScr,nil));
(GUI.List[id] as CGUICheckBox).POnChange := @SetFullScr;
(GUI.List[id] as CGUICheckBox).Font.Color:=$C8936D;
ChB1Id:=id;

id := GUI.AddElement(CreateCheckBox(nil,nil,GUIFont,MenuFon2.X+30,ScrH+50,16,16,' ', not EnableSound,nil));
(GUI.List[id] as CGUICheckBox).POnChange := @DisableSound;
(GUI.List[id] as CGUICheckBox).Font.Color:=$C8936D;
ChB2Id:=id;

end;

procedure MenuDraw;
begin
SSprite_Draw(FonImage,0,0,1024,768);
SSprite_Draw(ShadowEffect,0,0,ScrW,ScrH+2,255);

Pr2D_Rect(MenuFon1.X,0,MenuFon1.Width,MenuFonH1,$000000,80,PR_FILL);
Pr2D_Rect(MenuFon1.X+10,0,MenuFon1.Width-20,MenuFonH1-10,$000000,80,PR_FILL);
Pr2D_Rect(MenuFon2.X,ScrH-MenuFonH2,MenuFon2.Width,MenuFonH2,$000000,80,PR_FILL);
Pr2D_Rect(MenuFon2.X+10,ScrH-MenuFonH2+10,MenuFon2.Width-20,MenuFonH2-10,$000000,80,PR_FILL);
Pr2D_Rect(MenuFon2.X,trunc(ScrH/2-60)-90,MenuFon2.Width,260,$000000,80,PR_FILL);
Pr2D_Rect(MenuFon2.X+10,trunc(ScrH/2-60)-80,MenuFon2.Width-20,240,$000000,80,PR_FILL);

GUI.Draw;
end;

procedure MenuProcess;
var tb : boolean;
begin
if (ScrAlpha<8) then ScrAlpha:=0 else Dec( ScrAlpha, 7 );

if GoToGame then begin
 if ScrAlpha<240 then ScrAlpha:=ScrAlpha+15
  else begin
   tb:=Mouse_Press(M_LBUTTON) and Mouse_Press(M_RBUTTON);
   ScrAlpha:=255;
   GameInit;
   Scene:=sGame;
   GScene:=gsGame;
  end;
end;

if GoToScore then begin
 if ScrAlpha<240 then ScrAlpha:=ScrAlpha+15
  else begin
   ScrAlpha:=255;
   ScoreInit;
   Scene:=sScores;
  end;
end;

If Col_PointInAABB(Mouse_X,Mouse_Y,@MenuFon1) and (MenuFonH1<110) then begin
 Inc(MenuFonH1,5);
 MenuFon1.Height:=MenuFonH1;
 (GUI.List[LabelId] as CGUILabel).Y:=trunc(MenuFonH1-105);
 (GUI.List[EditId] as CGUIEdit).Y:=trunc(MenuFonH1-70);
end else begin
 If (not Col_PointInAABB(Mouse_X,Mouse_Y,@MenuFon1)) and (MenuFonH1>20) then begin
  Dec(MenuFonH1,5);
  MenuFon1.Height:=MenuFonH1;
  (GUI.List[LabelId] as CGUILabel).Y:=trunc(MenuFonH1-105);
  (GUI.List[EditId] as CGUIEdit).Y:=trunc(MenuFonH1-70);
 end;
end;

If Col_PointInAABB(Mouse_X,Mouse_Y,@MenuFon2) and (MenuFonH2<80) then begin
 Inc(MenuFonH2,5);
 MenuFon2.Height:=MenuFonH2;
 MenuFon2.Y:=ScrH-MenuFonH2;
 (GUI.List[ChB1Id] as CGUICheckBox).Y:=ScrH-MenuFonH2+20;
 (GUI.List[ChB2Id] as CGUICheckBox).Y:=ScrH-MenuFonH2+50;
end else begin
 If (not Col_PointInAABB(Mouse_X,Mouse_Y,@MenuFon2)) and (MenuFonH2>20) then begin
  Dec(MenuFonH2,5);
  MenuFon2.Height:=MenuFonH2;
  MenuFon2.Y:=ScrH-MenuFonH2;
  (GUI.List[ChB1Id] as CGUICheckBox).Y:=ScrH-MenuFonH2+20;
  (GUI.List[ChB2Id] as CGUICheckBox).Y:=ScrH-MenuFonH2+50;
 end;
end;

GUI.Process;
 (GUI.List[EditId] as CGUIEdit).X:=ScrW div 2-trunc(Text_GetWidth(GUIFont,PChar(PlayerName),1,0)) div 2;
PlayerName:=(GUI.List[EditId] as CGUIEdit).Caption;

end;

end.
