unit Utils;

interface

uses omega;

const statusEmpty = 1;
      statusMine  = 2;

type TGLRect = record
       x,y,w,h: integer;
     end;

type TTile = class
       isVisible  : boolean;
       Status     : integer;
       Flag       : boolean;
       CountMine  : integer;
       x,y        : integer;
       numX, numY : integer;
       Select     : boolean;
       procedure  Draw;
       procedure  Process;
     end;

type TRecordString = record
       Name: String[16];
       Time: integer;
     end;

type TPointWay = record
       x,y: integer;
     end;

var Pole:              array of array of TTile;
    PointWay:          array of TPointWay;
    //RecordTableEasy:   array[1..5] of TRecordString;
    //RecordTableMedium: array[1..5] of TRecordString;
    //RecordTableHard:   array[1..3,1..5] of TRecordString;
    RecordTable:   array[1..3,1..5] of TRecordString;

procedure CursorDraw;
procedure SmileDraw;
procedure PoleInit(width, height: integer);
procedure PoleDraw;
procedure PoleProcess;
procedure MineDraw(x,y: integer);
procedure FlagDraw(x,y: integer);
function  FreeTile(status: integer): boolean;
procedure FreePolePoint(var x,y: integer);
function  PointInRect(x,y: integer; r: TGLRect): boolean;
function  GLRect(x,y,w,h: integer): TGLRect;
procedure LoadRecordTable;
procedure SaveRecordTable;

implementation

uses main, gui, SysUtils;

procedure CursorDraw;
begin
  if DrawSprite = true then
  begin
    SSprite_Draw(texCursor,Mouse_X,Mouse_Y,24,24);
  end
  else
  begin
    Pr2D_LineWidth(2);
    Pr2D_Line(Mouse_X,Mouse_Y,Mouse_X,Mouse_Y+15,$FFFFFF);
    Pr2D_Line(Mouse_X,Mouse_Y+15,Mouse_X+3,Mouse_Y+11,$FFFFFF);
    Pr2D_Line(Mouse_X+3,Mouse_Y+11,Mouse_X+7,Mouse_Y+21,$FFFFFF);
    Pr2D_Line(Mouse_X+7,Mouse_Y+21,Mouse_X+9,Mouse_Y+19,$FFFFFF);
    Pr2D_Line(Mouse_X+9,Mouse_Y+19,Mouse_X+5,Mouse_Y+9,$FFFFFF);
    Pr2D_Line(Mouse_X+5,Mouse_Y+9,Mouse_X+9,Mouse_Y+9,$FFFFFF);
    Pr2D_Line(Mouse_X+9,Mouse_Y+9,Mouse_X,Mouse_Y,$FFFFFF);
  end;
end;

procedure SmileDraw;
begin
  if StatusGame = 2 then
  begin
    if DrawSprite = true then
    begin
      SSprite_Draw(texSmile2,OE_GetOptions.wnd_Width/2-16,38,32,32);
    end
    else
    begin
      Pr2D_LineWidth(2);
      Pr2D_Circle(OE_GetOptions.wnd_Width/2,52,14,$FFFFFF);
      Pr2D_PixelSize(4);
      Pr2D_Pixel(OE_GetOptions.wnd_Width/2-5,47,$FFFFFF);
      Pr2D_Pixel(OE_GetOptions.wnd_Width/2+5,47,$FFFFFF);
      Pr2D_PixelSize(2);
      Pr2D_Pixel(OE_GetOptions.wnd_Width/2,57,$FFFFFF);
      Pr2D_Pixel(OE_GetOptions.wnd_Width/2-2,57,$FFFFFF);
      Pr2D_Pixel(OE_GetOptions.wnd_Width/2-4,59,$FFFFFF);
      Pr2D_Pixel(OE_GetOptions.wnd_Width/2+2,57,$FFFFFF);
      Pr2D_Pixel(OE_GetOptions.wnd_Width/2+4,59,$FFFFFF);
    end;
  end
  else
  begin
    if DrawSprite = true then
    begin
      SSprite_Draw(texSmile1,OE_GetOptions.wnd_Width/2-16,38,32,32);
    end
    else
    begin
      Pr2D_LineWidth(2);
      Pr2D_Circle(OE_GetOptions.wnd_Width/2,52,14,$FFFFFF);
      Pr2D_PixelSize(4);
      Pr2D_Pixel(OE_GetOptions.wnd_Width/2-5,47,$FFFFFF);
      Pr2D_Pixel(OE_GetOptions.wnd_Width/2+5,47,$FFFFFF);
      Pr2D_PixelSize(2);
      Pr2D_Pixel(OE_GetOptions.wnd_Width/2,59,$FFFFFF);
      Pr2D_Pixel(OE_GetOptions.wnd_Width/2-2,59,$FFFFFF);
      Pr2D_Pixel(OE_GetOptions.wnd_Width/2-4,57,$FFFFFF);
      Pr2D_Pixel(OE_GetOptions.wnd_Width/2+2,59,$FFFFFF);
      Pr2D_Pixel(OE_GetOptions.wnd_Width/2+4,57,$FFFFFF);
    end;
  end;
end;

procedure PoleInit(width, height: integer);
var x,y: integer;
    mineNum: integer;
    xm,ym: integer;
    startx, starty: integer;
begin
  SetLength(Pole,width,height);
  startx:= OE_GetOptions.wnd_Width div 2-(Length(Pole)*24+(Length(Pole)*2)+2) div 2;
  starty:= 70;
  for x:= 0 to width-1 do
    for y:= 0 to height-1 do
    begin
      Pole[x,y]:= TTile.Create;
    end;
  for mineNum:= 1 to MineCount do
  begin
    FreePolePoint(x,y);
    Pole[x,y].Status:= statusMine;
  end;
  for x:= 0 to width-1 do
    for y:= 0 to height-1 do
    begin
      Pole[x,y].isVisible:= false;
      Pole[x,y].Flag:= false;
      Pole[x,y].CountMine:= 0;
      Pole[x,y].Select:= false;
      Pole[x,y].x:= startx+x*24+x*2+2;
      Pole[x,y].y:= starty+y*24+y*2+2;
      Pole[x,y].numX:= x;
      Pole[x,y].numY:= y;
      if Pole[x,y].Status <> statusMine then
      begin
        Pole[x,y].Status:= statusEmpty;
        for xm:= x-1 to x+1 do
          for ym:= y-1 to y+1 do
          begin
            if (xm >= 0) and (xm <= PoleWidth-1) and (ym >= 0) and (ym <= PoleHeight-1) then
              if Pole[xm,ym].Status = statusMine then
                inc(Pole[x,y].CountMine);
          end;
      end;
    end;
end;

procedure PoleDraw;
var x,y: integer;
    startx, starty: integer;
begin
  startx:= OE_GetOptions.wnd_Width div 2-(Length(Pole)*24+(Length(Pole)*2)+2) div 2;
  starty:= 70;
  Pr2D_Rect(startx,starty,
            Length(Pole)*24+Length(Pole)*2+2,Length(Pole[2])*24+Length(Pole[2])*2+2,
            $999999,255,PR_FILL);
  for x:= 0 to Length(Pole)-1 do
    for y:= 0 to Length(Pole[2])-1 do
    begin
      Pole[x,y].Draw;
    end;
end;

procedure PoleProcess;
var x,y: integer;
begin
  for x:= 0 to Length(Pole)-1 do
    for y:= 0 to Length(Pole[2])-1 do
    begin
      Pole[x,y].Process;
    end;
end;

procedure MineDraw(x,y: integer);
begin
  if DrawSprite = true then
  begin
    SSprite_Draw(texMine,x,y,24,24);
  end
  else
  begin
    Pr2D_LineWidth(2);
    Pr2D_Circle(x+12,y+12,8,$FFFFFF);
    Pr2D_PixelSize(2);
    Pr2D_Pixel(x+2,y+12,$FFFFFF);
    Pr2D_Pixel(x+12,y+2,$FFFFFF);
    Pr2D_Pixel(x+22,y+12,$FFFFFF);
    Pr2D_Pixel(x+12,y+22,$FFFFFF);
  end;
end;

procedure FlagDraw(x,y: integer);
begin
  if DrawSprite = true then
  begin
    SSprite_Draw(texFlag,x,y,24,24);
  end
  else
  begin
    Pr2D_LineWidth(2);
    Pr2D_Line(x+8,y+22,x+8,y+3,$FFFFFF);
    Pr2D_Triangle(x+8,y+17,x+8,y+4,x+19,y+10,$FFFFFF);
  end;
end;

//------------------------------------------------------------------------------
function FreeTile(status: integer): boolean;
begin
  if Status = statusMine then
    FreeTile:= False
  else
    FreeTile:= True;
end;

//------------------------------------------------------------------------------
procedure FreePolePoint(var x,y: integer);
begin
  repeat
    x := random(PoleWidth);
    y := random(PoleHeight);
  until
    FreeTile(Pole[x,y].Status);
end;

function PointInRect(x,y: integer; r: TGLRect): boolean;
begin
  if (x >= r.x) and (x <= r.x+r.w) and (y >= r.y) and (y <= r.y+r.h) then
    Result:= True
  else
    Result:= False;
end;

function GLRect(x,y,w,h: integer): TGLRect;
begin
  Result.x:= x;
  Result.y:= y;
  Result.w:= w;
  Result.h:= h;
end;

procedure OpenTile(StartX, StartY: integer);
  procedure DeleteWayPoint(numPoint: integer);
  var numW: integer;
  begin
    for numW:= 0 to Length(PointWay)-numPoint-1 do
    begin
      PointWay[numW].x:= PointWay[numPoint+numW].x;
      PointWay[numW].y:= PointWay[numPoint+numW].y;
    end;
    SetLength(PointWay,Length(PointWay)-numPoint);
  end;
  procedure AddWayPoint(px,py,count: integer);
  var numW: integer;
  begin
    if Pole[px,py].isVisible = true then
      exit;
    if count = 0 then
    begin
      numW:= Length(PointWay)+1;
      SetLength(PointWay,numW);
      PointWay[numW-1].x:= px;
      PointWay[numW-1].y:= py;
      Pole[px,py].isVisible:= true;
    end
    else
    begin
      Pole[px,py].isVisible:= true;
    end;
    OpenPole:= OpenPole+1;
  end;
var i,l: integer;
begin
  SetLength(PointWay,0);
  AddWayPoint(StartX,StartY,0);
  while Length(PointWay) <> 0 do
  begin
    l:= Length(PointWay)-1;
    for i:= 0 to l do
    begin
      if (PointWay[i].x-1 >=0) then
      begin
        AddWayPoint(PointWay[i].x-1,PointWay[i].y,
                    Pole[PointWay[i].x-1,PointWay[i].y].CountMine);
      end;
      if (PointWay[i].y-1 >=0) then
      begin
        AddWayPoint(PointWay[i].x,PointWay[i].y-1,
                    Pole[PointWay[i].x,PointWay[i].y-1].CountMine);
      end;
      if (PointWay[i].x+1 <=PoleWidth-1) then
      begin
        AddWayPoint(PointWay[i].x+1,PointWay[i].y,
                    Pole[PointWay[i].x+1,PointWay[i].y].CountMine);
      end;
      if (PointWay[i].y+1 <=PoleHeight-1) then
      begin
        AddWayPoint(PointWay[i].x,PointWay[i].y+1,
                    Pole[PointWay[i].x,PointWay[i].y+1].CountMine);
      end;
      if (PointWay[i].x-1 >=0) and (PointWay[i].y-1 >=0) then
      begin
        AddWayPoint(PointWay[i].x-1,PointWay[i].y-1,
                    Pole[PointWay[i].x-1,PointWay[i].y-1].CountMine);
      end;
      if (PointWay[i].x+1 <=PoleWidth-1) and
         (PointWay[i].y-1 >=0) then
      begin
        AddWayPoint(PointWay[i].x+1,PointWay[i].y-1,
                    Pole[PointWay[i].x+1,PointWay[i].y-1].CountMine);
      end;
      if (PointWay[i].y+1 <=PoleHeight-1) and
         (PointWay[i].x-1 >=0) then
      begin
        AddWayPoint(PointWay[i].x-1,PointWay[i].y+1,
                    Pole[PointWay[i].x-1,PointWay[i].y+1].CountMine);
      end;
      if (PointWay[i].y+1 <=PoleHeight-1) and
         (PointWay[i].x+1 <=PoleWidth-1) then
      begin
        AddWayPoint(PointWay[i].x+1,PointWay[i].y+1,
                    Pole[PointWay[i].x+1,PointWay[i].y+1].CountMine);
      end;
    end;                 
    DeleteWayPoint(l+1);
  end;;
end;

{ TTile }

procedure TTile.Draw;
begin
  if isVisible = true then
  begin
    if Select then
    begin
      if DrawSprite = true then
      begin
        SSprite_Draw(texTile1,x,y,24,24,155);
      end
      else
      begin
        Pr2D_Rect(x,y,24,24,$555555,155,PR_FILL);
      end;
    end
    else
    begin
      if DrawSprite = true then
      begin
        SSprite_Draw(texTile1,x,y,24,24);
      end
      else
      begin
        Pr2D_Rect(x,y,24,24,$555555,255,PR_FILL);
      end;
    end;
    if Status = statusMine then
      MineDraw(x,y);
    if CountMine > 0 then
    begin
      if DrawSprite = true then
        Text_Draw(Font,x+8,y+6,U_IntToStr(CountMine),1,0,255,$000000)
      else
        Text_Draw(Font,x+8,y+6,U_IntToStr(CountMine));
    end;
  end
  else
    if Select then
    begin
      if DrawSprite = true then
      begin
        SSprite_Draw(texTile2,x,y,24,24,155);
      end
      else
      begin
        Pr2D_Rect(x,y,24,24,$000000,155,PR_FILL);
      end;
    end
    else
    begin
      if DrawSprite = true then
      begin
        SSprite_Draw(texTile2,x,y,24,24);
      end
      else
      begin
        Pr2D_Rect(x,y,24,24,$000000,255,PR_FILL);
      end;
    end;
  if (Flag = true) and (StatusGame <> 2) then
    FlagDraw(x,y);
end;

procedure TTile.Process;
begin
  if PointInRect(Mouse_X,Mouse_Y,GlRect(x,y,24,24)) then
  begin
    Select:= true;
    if Mouse_Click(M_RBUTTON) then
    begin
      StartGame:= true;
      if Flag = true then
      begin
        Flag:= false;
        FlagCount:= FlagCount+1;
        if Status = statusMine then
          FlagOnMine:= FlagOnMine-1;
      end
      else
      begin
        Flag:= true;
        FlagCount:= FlagCount-1;
        if Status = statusMine then
          FlagOnMine:= FlagOnMine+1;
      end;
    end;
    if Mouse_Click(M_LBUTTON) then
    begin
      StartGame:= true;
      if Flag = true then
      begin
        exit;
      end;
      if Status = statusMine then
      begin
        IdExpl:= Snd_Play(SoundExpl);
        LooseGame;
        exit;
      end;
      if CountMine = 0 then
      begin
        idEmpty:= Snd_Play(SoundEmpty);
        OpenTile(numX,numY);
      end
      else
      begin
        idEmpty:= Snd_Play(SoundEmpty);
        isVisible:= true;
        OpenPole:= OpenPole+1;
      end;
    end;
  end
  else
  begin
    Select:= false;
  end;
end;

procedure LoadRecordTable;
var numLevel, numStr: integer;
    F: file;
begin
  if FileExists('record.txt') = true then
  begin
    Assign(F, 'record.txt');
    Reset(F,1);
    for numLevel:= 1 to 3 do
      for numStr:= 1 to 5 do
      begin
        BlockRead(F,RecordTable[numLevel, numStr].Name,
                  SizeOf(RecordTable[numLevel, numStr].Name));
        BlockRead(F,RecordTable[numLevel, numStr].Time,
                  SizeOf(RecordTable[numLevel, numStr].Time));
      end;
    Close(F);
  end
  else
    SaveRecordTable;
end;

procedure SaveRecordTable;
var numLevel, numStr: integer;
    F: file;
begin
  if FileExists('record.txt') = false then
  begin
  for numLevel:= 1 to 3 do
    for numStr:= 1 to 5 do
    begin
      RecordTable[numLevel, numStr].Name:= '';
      RecordTable[numLevel, numStr].Time:= 999;
    end;
  end;
  Assign(F, 'record.txt');
  Rewrite(F,1);
  for numLevel:= 1 to 3 do
    for numStr:= 1 to 5 do
    begin
      BlockWrite(F,RecordTable[numLevel, numStr].Name,
                SizeOf(RecordTable[numLevel, numStr].Name));
      BlockWrite(F,RecordTable[numLevel, numStr].Time,
                SizeOf(RecordTable[numLevel, numStr].Time));
    end;
  Close(F);
end;

end.
