unit GMMap;

interface
     uses OpenGl,Windows,GMVars,GMUtilite,Textures,log,IDX_sound;

type
   Tmap=object
     MapW : Integer;
     MapH : Integer;

     CellX,CellY:Integer;

     cTime:record
                 mSec:Byte;
                 Sec:Byte;
                 Min:Byte;
                 Hour:Byte;
                 LongTime:Integer;
                 OldTime:DWORD;
                 Enable:Boolean;
                 end;

     Cells:array of array of  record
                     Value:Integer;
                     Flag:Boolean;
                     Mine:Integer;
                     Visible:Boolean;
                     end;

     Mines,Flags,InitFlags:Integer;
     TilesCount:Integer;

     CurrentLevel:integer;

     state:Byte;

     targx:Integer;
     targy:Integer;
     targon:Boolean;
     clickdue:Boolean;

     xoffset,yoffset:Integer;

  Texture:array[0..10] of cardinal;

  TextureFlag:Cardinal;
  TextureMinaOn:Cardinal;
  TextureMinaOff:Cardinal;
  TextureMinaError:Cardinal;
  TexturePanel:Cardinal;

  TextureBack:array[0..10] of Cardinal;

  TexturePaper:array[0..4] of Cardinal;
  TextureRabit:array[0..1] of Cardinal;
  NumberTexture:array[0..7] of Cardinal;

  procedure Init(mx,my,mn:Integer);
  procedure Load;
  procedure Close;
  procedure Draw;
  procedure Procces;

  procedure generateTNT;
  function findCell:Boolean;
  procedure checkM(x, y:Integer;var value:Integer);

  procedure recurse(x,y:Integer;z:Boolean=False);
  procedure recurseSurroundings(x,y:Integer);
  procedure checkWin;
  procedure gameover;
  procedure Reset;

  procedure TimeProcces;
  procedure TimeReset;
  end;


var
 Mymap:Tmap;
 screenBoom:Boolean=False;
 screenCount:Integer=0;

procedure ProccesGame;
procedure Render;
Procedure InitGame;
Procedure CloseGame;
implementation
        uses GMWindow,HighScores;


procedure Tmap.TimeProcces;
var
  gwTime:DWORD;
begin
  if cTime.Enable=False then Exit;

  gwTime:= GetTimer;

  while Abs(gwTime-cTime.OldTime) >= 100 do
  begin
    cTime.OldTime:=gwTime;
    inc(cTime.mSec);
    if cTime.mSec>10 then
    begin
       cTime.mSec:=0;
       Inc(cTime.Sec);
       Inc(cTime.LongTime);
       if (cTime.Sec>59) then
       begin
         cTime.Sec:=0;
         Inc(cTime.Min);
         if (cTime.Min>59) then
         begin
           cTime.Min:=0;
           Inc(cTime.Hour);
           if cTime.Hour>23 then cTime.Hour:=0;
         end;
       end;
    end;
  end;

end;

procedure Tmap.TimeReset;
begin
 cTime.mSec:=0;
 cTime.Sec:=0;
 cTime.Min:=0;
 cTime.Hour:=0;
 cTime.LongTime:=0;
 cTime.OldTime:=GetTimer;
 cTime.Enable:=False;
end;

procedure Tmap.Reset;
begin

 state:=0;
 clickdue:= false;
 CellX:=-1;
 CellY:=-1;
 

 case CurrentLevel of
  0: begin
      Init(9,14,14);
      xoffset:=422;
      yoffset:=293;
     end;
  1: begin
      Init(14,14,20);
      xoffset:=422;
      yoffset:=100;
     end;
  2: begin
      Init(16,14,25);
       xoffset:=380;
       yoffset:=100;
     end;
 end;

end;

procedure Tmap.Gameover;
var
  i,j:Integer;
  c:Integer;
begin

   for i:=0 to MapW do
   for j:=0 to MapH do
   begin
            if (Cells[i,j].Flag) then
            begin
                if (Cells[i,j].Mine=0 ) then Cells[i,j].Mine:=4;
                if (Cells[i,j].Mine=1 ) then Cells[i,j].Mine:=2;
            end
            else
            if (Cells[i,j].Mine=1 ) then
            begin
              Cells[i,j].Mine:=3;
            end;
   end;

   Cells[CellX,CellY].Mine:=5; //
   state:=2;
   PlayEffect('Boom.mp3');
   cTime.Enable:=False;

end;


procedure Tmap.checkWin;
var
  i,j:integer;
begin
    if (TilesCount - initFlags) <=1 then
    begin

        flags:= 0;

        for i:=0 to MapW do
        for j:=0 to MapH do
        begin

          if (Cells[i,j].Mine=1)or (Cells[i,j].Visible) then
          begin
             Cells[i,j].Mine:=2;
          end;

        end;
        state:=1;
        cTime.Enable:=False;
    end;
end;

procedure Tmap.recurseSurroundings(x,y:Integer);
begin
    recurse(x, y + 1);
    recurse(x, y - 1);
    recurse(x + 1, y);
    recurse(x - 1, y);
    recurse(x + 1, y + 1);
    recurse(x - 1, y + 1);
    recurse(x + 1, y - 1);
    recurse(x - 1, y - 1);
end;


procedure Tmap.recurse(x,y:Integer;z:Boolean=False);
begin

    if x<0 then x:=0;
    if y<0 then y:=0;

    if x>MapW then x:=MapW;
    if y>MapH then y:=MapH;


    if (not Cells[x,y].Visible) then
    begin
        exit;
    end;

    if (Cells[x,y].Mine=1 ) then
    begin
        if (not Cells[x,y].Flag) then
        begin
            gameOver();
            Exit;
        end;
    end;

    Cells[x,y].Visible:= False;

    checkWin();

    if (z) then
    begin
        if (not Cells[x,y].Flag) then
        begin
            if (Cells[x,y].Value > 0) then
            begin

            end
            else
            begin
                recurseSurroundings(x, y);
            end;


            Dec(TilesCount);
        end; // end if
        Exit;
    end
    else
    begin
        if (Cells[x,y].Flag) then
        begin
            Inc(flags);
        end; // end if
        if (Cells[x,y].Value>0 ) then
        begin
            Dec(TilesCount);
            Exit;
        end;
    end;

    Dec(TilesCount);
    recurseSurroundings(x, y);
end;

procedure Tmap.Procces;
var
  count,kaka:Integer;
begin

  if state=1 then  //
  begin
     if Keys[13] then
     begin

        if ShowSetName(cTime.LongTime) then
        begin
            if length(EnterName)=0 then EnterName:='';

            SetName(EnterName,cTime.LongTime,AddZero(cTime.hour)+':'+
                                             AddZero(cTime.Min)+':'+
                                             AddZero(cTime.Sec));
            SaveHSTable;
        end;

       Inc(CurrentLevel);
       if CurrentLevel>2 then CurrentLevel:=0;
       Reset;

       Keys[13]:=false;
     end;
     if Keys[VK_ESCAPE] then
     begin
       CurrentLevel:=0;
       GameStatus:=sGMenu;
       Keys[VK_ESCAPE]:=false;
     end;

    Exit;
  end;

  if state=2 then  //
  begin
     if Keys[VK_Space] then
     begin
       Reset;
       Keys[VK_Space]:=false;
     end;
     if Keys[VK_ESCAPE] then
     begin
       GameStatus:=sGMenu;
       Keys[VK_ESCAPE]:=false;
     end;
    Exit;
  end;


//
 if Keys[VK_ESCAPE] then
 begin
   GameStatus:=sGMenu;
   Keys[VK_ESCAPE]:=false;
 end;


   if Keys[MouseRB] then
   begin


     if findCell then
     begin

       cTime.Enable:=True;

       if Cells[CellX,CellY].Visible then
       begin
        if  Cells[CellX,CellY].Flag then
        begin
         Inc(flags);
         Cells[CellX,CellY].Flag:=False;
        end
        else
        begin
         if flags>0 then
         begin
          Dec(flags);
          Cells[CellX,CellY].Flag:=True;
          checkWin;
         end;
        end;
       end;
     end;

     Keys[MouseRB]:=false;
   end;

 if Keys[MouseLB] then
 begin

   if findCell then
   begin
        if (Cells[CellX,CellY].Flag) then
        begin
            clickdue:= false;
        end
        else
        if (Cells[CellX,CellY].Visible) then
        begin
            targx:= CellX;
            targy:= CellY;
            targon:=True;
            clickdue:= true;
        end
        else
        if (Cells[CellX,CellY].Value> 0)then
        begin
            targx:= CellX;
            targy:= CellY;
            targon:=True;
            clickdue:= true;
        end
        else
        begin
            clickdue:= false;
        end; // end if
  end;
     Keys[MouseLB]:=false;
 end;

 if isKeyUP then
 begin
  if (clickdue) then
  begin
    if findCell then
    begin
            if (targx = CellX)and (targy = CellY) then
            begin
                    if (Cells[targx,targy].Mine=1) then
                    begin
                      gameOver;
                      screenBoom:=True;
                      
                      Exit;
                    end;

                    cTime.Enable:=true;

                    PlayEffect('hrum.wav');
                    
                    recurse(CellX, CellY);
                    targon:= false;
            end;
    end;
  end;
    isKeyUP:=False;
 end;

end;

procedure Tmap.checkM(x, y:Integer;var value:Integer);
begin
    if x<0 then x:=0;
    if y<0 then y:=0;

    if x>MapW then x:=MapW;
    if y>MapH then y:=MapH;

    if (Cells[x,y].Flag) then
    begin
        Inc(value);
    end;
end;

function Tmap.findCell:Boolean;
var
    visx, visy,
    wx, wy: integer;
begin
   Result:=True;

   wx :=  MousePos.X-Xoffset;
   wy :=  MousePos.Y-Yoffset;

  CellX := trunc((wx/48)+(wy/24));
  CellY := trunc((wy/24)-(wx/48));;

  if (CellX<0)or(CellY<0)or(CellX>mapW)or(CellY>mapH) then
  begin
    CellX:=-1;
    CellY:=-1;
    Result:=False;
  end;
end;


procedure Tmap.generateTNT;
var
  i,j,x,y:Integer;
begin

    for i:=0 to MapW do
    for j:=0 to MapH do
    begin
         Cells[i,j].Mine:=0;
         Cells[i,j].Value:= 0;
    end;

    i:= 0;
    while (i < mines) do
    begin
        x:= random(MapW-1)+1;
        y:= random(MapH-1)+1;
        if (Cells[x,y].Mine = 0) then
        begin
            Cells[x,y].Mine:= 1;
            Inc(Cells[x - 1,y - 1].Value);
            Inc(Cells[x - 1,y + 0].Value);
            Inc(Cells[x - 1,y + 1].Value);
            Inc(Cells[x + 0,y - 1].Value);
            Inc(Cells[x + 0,y + 1].Value);
            Inc(Cells[x + 1,y - 1].Value);
            Inc(Cells[x + 1,y + 0].Value);
            Inc(Cells[x + 1,y + 1].Value);
            Inc(i);
        end; // end if
    end;


end;

procedure Tmap.Draw;

var
  i,j,u,v,px,py:Integer;
  c:Integer;
  s:string;
  smx,smy:Integer;
begin
 glBlend(1);

 TimeProcces;
 findCell;

 if CurrentLevel=0 then
  DrawTextureBox(0,0,SCRW,SCRH,TextureBack[1])
 else
   DrawTextureBox(0,0,SCRW,SCRH,TextureBack[2]);

 for i:=0 to MapW do
 for j:=0 to MapH do
 begin
     u:=i-j;
     v:=i+j;
     px:= (u * 24) + Xoffset;
     py:= (v * 12) + Yoffset;

   if state=0 then
   begin
     if (CellX=i) and (CellY=j) then
     begin
      if Cells[i,j].Visible then
      DrawTextureBox(px,py+12,64,64,Texture[2],$FFFFFF,255,True );
     end
     else
     begin
       if Cells[i,j].Visible then
       DrawTextureBox(px,py+12,64,64,Texture[1],$FFFFFF,255,True);
     end;

     if Cells[i,j].Flag and Cells[i,j].Visible then
     DrawTextureBox(px,py,32,32,TextureFlag,$FFFFFF,255,True);
   end;

   if (state>0) then
   begin

    if Cells[i,j].Visible and (Cells[i,j].Mine=0) then
    DrawTextureBox(px,py+12,64,64,Texture[1],$FFFFFF,255,True);

     if Cells[i,j].Mine=2 then
     begin
      DrawTextureBox(px,py+12,64,64,TextureMinaOff,$FFFFFF,255,True);
      DrawTextureBox(px,py,32,32,TextureFlag,$FFFFFF,255,True);
     end;

     if Cells[i,j].Mine=3 then
     begin
      DrawTextureBox(px,py+12,64,64,TextureMinaOff,$FFFFFF,255,True);
     end;

     if Cells[i,j].Mine=4 then
     begin
      DrawTextureBox(px,py+12,64,64,TextureMinaError,$FFFFFF,255,True);
     end;

     if Cells[i,j].Mine=5 then
     begin
      DrawTextureBox(px,py+12,64,64,TextureMinaOn,$FFFFFF,255,True);
     end;

   end;

      if Cells[i,j].Visible=False then
      begin
          if (Cells[i,j].Value>0)and(Cells[i,j].Mine=0)  then
          begin
           DrawTextureBox(px,py+4,32,32,NumberTexture[Cells[i,j].Value-1],$FFFFFF,255,True);
          end;
      end;

 end;

  DrawTextureBox(SCRW-256,0,256,128,TexturePanel);

  SText2D(MySysfont,AddZero(cTime.Min)+':'+
                    AddZero(cTime.Sec)+':'+
                    AddZero(cTime.mSec),SCRW-120 ,70,Rgb(255,255,255),255);

 SText2D(MySysfont,IntToStr(flags),SCRW-70 ,45,Rgb(255,255,255),255);

 if state=1 then
 begin
   DrawTextureBox(SCR2W-256,SCR2H-256,512,512,TexturePaper[0],$ffffff,210);
   glBlend(3);
   DrawTextureBox(SCR2W-256,SCR2H-130,512,64,TexturePaper[1]);
   DrawTextureBox(SCR2W-200,SCR2H-120,128,256,TextureRabit[0]);

   SText2D(MySysfont,',    ',SCR2W-80,SCR2H-40,Rgb(0,0,0),255);
   SText2D(MySysfont,'  ,  ',SCR2W-80,SCR2H-20,Rgb(0,0,0),255);
   SText2D(MySysfont,'..',SCR2W-80,SCR2H,Rgb(0,0,0),255);
   SText2D(MySysfont,'   .',SCR2W-80,SCR2H+20,Rgb(0,0,0),255);

   if ShowSetName(cTime.LongTime) then
   begin
    SText2D(MySysfont,',     ',SCR2W-80,SCR2H+40,Rgb(255,0,0),255);
    SText2D(MySysfont,'   ',SCR2W-80,SCR2H+60,Rgb(255,0,0),255);
    SText2D(MySysfont,'    :',SCR2W-80,SCR2H+80,Rgb(255,0,0),255);
    SText2D(MySysfont,EnterName+'_',SCR2W-80,SCR2H+100,Rgb(0,0,0),255);
   end;

   SText2D(MySysfont,' "Enter"  ',SCR2W-180,SCR2H+125,Rgb(0,0,0),255);
   SText2D(MySysfont,' "ESC"     ',SCR2W-210,SCR2H+145,Rgb(0,0,0),255);

 end;

 if state=2 then
 begin
   DrawTextureBox(SCR2W-256,SCR2H-256,512,512,TexturePaper[0],$ffffff,210);
   glBlend(3);
   DrawTextureBox(SCR2W-256,SCR2H-130,512,64,TexturePaper[2]);
   DrawTextureBox(SCR2W-200,SCR2H-120,128,256,TextureRabit[1]);

   SText2D(MySysfont,'    ',SCR2W-80,SCR2H,Rgb(0,0,0),255);
   SText2D(MySysfont,'    ...',SCR2W-80,SCR2H+20,Rgb(0,0,0),255);
   SText2D(MySysfont,'    ',SCR2W-80,SCR2H+40,Rgb(0,0,0),255);
   SText2D(MySysfont,' .',SCR2W-80,SCR2H+60,Rgb(0,0,0),255);


   SText2D(MySysfont,' ""   ',SCR2W-180,SCR2H+120,Rgb(0,0,0),255);
   SText2D(MySysfont,' "ESC"     ',SCR2W-210,SCR2H+140,Rgb(0,0,0),255);

 end;
end;

procedure Tmap.Init;
var
  i,j:Integer;
begin

     MapW:=mx;
     MapH:=my;

     Mines:=mn;
     Flags:=Mines;
     InitFlags:=Mines;
     state:=0;

     TilesCount:=(MapW+1)*(MapH+1);

    SetLength(Cells,MapW+1,MapH+1);

    for i:=0 to MapW do
    for j:=0 to MapH do
    begin
         Cells[i,j].Value:= 0;
         Cells[i,j].Visible:=True;
         Cells[i,j].Flag:=False;
         Cells[i,j].Mine:=0;
    end;

   generateTNT;
   TimeReset;
end;

procedure Tmap.Load;
var
  i:Integer;
begin
    CurrentLevel:=0;

    LoadTexture('data\gfx\titul.jpg',TextureBack[0]);
    LoadTexture('data\gfx\back.jpg',TextureBack[1]);
    LoadTexture('data\gfx\back2.jpg',TextureBack[2]);

    LoadTexture('data\gfx\select.png',Texture[0]);
    LoadTexture('data\gfx\tile1_1.png',Texture[1]);
    LoadTexture('data\gfx\tile1S_1.png',Texture[2]);

    LoadTexture('data\gfx\flag2.png',TextureFlag);

    LoadTexture('data\gfx\MinaOn.png',TextureMinaOn);
    LoadTexture('data\gfx\MinaOff.png',TextureMinaOFF);
    LoadTexture('data\gfx\MinaError.png',TextureMinaError);

    LoadTexture('data\gfx\Panel.png',TexturePanel);

    LoadTexture('data\gfx\paper.png',TexturePaper[0]);
    LoadTexture('data\gfx\victory1.png',TexturePaper[1]);
    LoadTexture('data\gfx\gameover1.png',TexturePaper[2]);

    LoadTexture('data\gfx\Rabbit.png',TextureRabit[0]);
    LoadTexture('data\gfx\Rabbit2.png',TextureRabit[1]);

    for i:=0 to 7 do
    LoadTexture('data\gfx\c'+inttostr(i+1)+'.png',NumberTexture[i]);


    Reset;
end;

procedure Tmap.Close;
 begin
 end;

Procedure InitGame;
begin
 Randomize;
 OpenLog;
 InitSoundEngine;
 LoadHSTable;
 Mymap.Load;
 PlayMusic('music.mp3');
end;

Procedure CloseGame;
var
  i:Integer;
begin
  FreeSoundEngine;
 SaveHSTable;
  CloseLog;

   for i:=0 to High(mymap.Texture) do
   glDeleteTextures(1,@mymap.Texture[i]);

   for i:=0 to High(mymap.TextureBack) do
   glDeleteTextures(1,@mymap.TextureBack[i]);

   for i:=0 to High(mymap.TexturePaper) do
   glDeleteTextures(1,@mymap.TexturePaper[i]);

   for i:=0 to High(mymap.TextureRabit) do
   glDeleteTextures(1,@mymap.TextureRabit[i]);

  glDeleteTextures(1,@mymap.TextureFlag);
  glDeleteTextures(1,@mymap.TextureMinaOn);
  glDeleteTextures(1,@mymap.TextureMinaOff);
  glDeleteTextures(1,@mymap.TextureMinaError);
  glDeleteTextures(1,@mymap.TexturePanel);

end;

procedure ProccesGame;
begin

 if GameStatus=sGame then
 begin
  Mymap.Procces;
  Exit;
 end;

 if Keys[VK_ESCAPE] then PostQuitMessage(0);

   if Keys[MouseLB] then
   begin
     if PointInRect(MousePos.X,MousePos.Y,SCRW-286,190,266,40) then
     begin
       GameStatus:=sGame;
     end;

     if PointInRect(MousePos.X,MousePos.Y,SCRW-286,280,266,30) then
     begin
      LoadHSTable;
      GameStatus:=sRecords;
     end;

     if PointInRect(MousePos.X,MousePos.Y,SCRW-190,350,160,30) then
     begin
       PostQuitMessage(0);
     end;

     Keys[MouseLB]:=false;
   end;

end;


procedure Render;
var
  i:integer;
begin

  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glPushMatrix;

  glDisable( GL_TEXTURE_2D );
  Enable2d(true);

  if GameStatus = sGame then
  Mymap.Draw;

  if GameStatus <> sGame then
  begin
    DrawTextureBox(0,0,SCRW,SCRH,Mymap.TextureBack[0]);

    if GameStatus=sRecords then
    begin
       DrawTextureBox(SCR2W-128,SCR2H-128,256,256,Mymap.TexturePaper[0],$ffffff,210);
       SText2D(MySysfont2,'',SCR2W-110,SCR2H-60,Rgb(0,0,0),255);
       SText2D(MySysfont2,'',SCR2W-40,SCR2H-60,Rgb(0,0,0),255);
       SText2D(MySysfont2,'',SCR2W+40,SCR2H-60,Rgb(0,0,0),255);

       for i:=1 to 3 do
       begin
         SText2D(MySysfont2,IntToStr(i)+'.',  SCR2W-110,(i*16)+SCR2H-40,Rgb(0,0,0),255);
         SText2D(MySysfont2,HSTable[i].Name,  SCR2W-60,(i*16)+SCR2H-40,Rgb(0,0,0),255);
         SText2D(MySysfont2,HSTable[i].sScore,SCR2W+40,(i*16)+SCR2H-40,Rgb(0,0,0),255);
       end;


    end;

  end;

  if screenBoom then
  begin
     glBlend(1);
   Inc(screenCount);
   DrawRectangle2D(0,0,SCRW,SCRH,$FFFFFF,Random(150)+100-screenCount,0,true,false);
   if screenCount>20 then
   begin
    screenCount:=0;
    screenBoom:=False;
   end;
  end;

 glBlend(1);
 Enable2d(false);
 glPopMatrix;
 SwapBuffers(GWDC);

end;

end.






