///////////////////////////////////////
//   Unit : GMUtilite
//   Date : 02/04/2005
// Author : Amosow 'Gambit_OZ' Evgeniy
// e-Mail : greenrat@mail333.com
///////////////////////////////////////
unit GMUtilite;

interface
      uses Windows,OpenGl,GMVars,SysUtils;


procedure Enable2d(A:boolean);
procedure glBlend(ID: Byte);
procedure VBL2(vsync : TVSyncMode);
procedure FreeSystemFont2D(font: DWORD); stdcall;
function GetTimer: integer;
function ExtractFileDir(const FileName: string): string;
function CreateSystemFont2D(AD:hDC;Face: PChar; W, H: integer): DWORD; stdcall;
procedure SText2D(font: DWORD; const str: string; X, Y, color: integer; Alpha : byte); stdcall;
procedure DrawRectangle2D(X, Y, Width, Height, Color:integer; Alpha : byte=255;Angle:integer=0; Fill : boolean = false;Center:boolean=false);
function IntToStr(x: integer): string;
function StrToInt(const S: string): Integer;
procedure DrawTextureBox(x,y,w,h:single;
                         textId:cardinal;
                         color: integer=$FFFFFF;
                         Alpha : byte=255;
                         center:boolean=false;
                         angle:integer=0);

procedure ReadOptions(Name:string);
function Maxi(a,b:Integer):Integer;
function getDistance( x1, y1:single; x2,y2:single ):single;
function PointInRect(X,Y:Single;Rx,RY,Rw,Rh:Single):Boolean;
 function AddZero(Number:Integer):string;
implementation
 uses IniFile,IDX_sound;

function AddZero(Number:Integer):string;
begin
  if Number<10 then
   Result:='0'+inttostr(Number)
  else
   Result:=inttostr(Number);
end;
function PointInRect(X,Y:Single;Rx,RY,Rw,Rh:Single):Boolean;
begin
  Result := ( X > RX ) and ( X < RX + RW ) and
            ( Y > RY ) and ( Y < RY + RH );
end;


function getDistance( x1, y1:single; x2,y2:single ):single;
var
xd2,yd2,d:single;
begin
    xd2 := (x2-x1)*(x2-x1);
    yd2 := (y2-y1)*(y2-y1);
    d   := xd2+yd2;
    if(d<0.0) then d:=-d;
    result:=sqrt(d);
end;

function Maxi(a,b:Integer):Integer;
begin
  Result:=b;
  if a>b then result:=a;

end;

function ReadValueFromIniFile(Filename, Section, Key, Default: string):string; stdcall;
var ini : TIniFile;
begin
result:='';
if fileexists(Filename) then
begin
ini:=TIniFile.Create(Filename);
result:=ini.GetIniSectionKeyValue(Section,Key);

if result='-1' then result:=Default;
ini.Free;
end
else
  result:=Default;

end;

procedure ReadOptions(Name:string);
var
  ini : TIniFile;
  S:string;
  Loading:boolean;
  i,j,k,Myk:integer;
begin

 SCRW   :=strtoint(ReadValueFromIniFile(Name,'Screen','Width','800'));
 SCRH   :=strtoint(ReadValueFromIniFile(Name,'Screen','Height','600'));
 SCRBit :=strtoint(ReadValueFromIniFile(Name,'Screen','Bit','32'));
 SCRHZ  :=strtoint(ReadValueFromIniFile(Name,'Screen','Herz','60'));

 s:=ReadValueFromIniFile(Name,'Screen','Sync','1');
 if s='1' then Sync:=true else Sync:=false;

 s:=ReadValueFromIniFile(Name,'Screen','FullScreen','0');
 if s='1' then FullScreen:=true else FullScreen:=false;

 s:=ReadValueFromIniFile(Name,'Screen','CenterScreen','1');
 if s='1' then CenterScreen:=true else CenterScreen:=false;

 s:=ReadValueFromIniFile(Name,'Media','PlayMusic','0');
 if s='1' then playingmusic:=true else playingmusic:=false;

 s:=ReadValueFromIniFile(Name,'Media','PlaySound','0');
 if s='1' then playingsound:=true else playingsound:=false;

 SCR2W:=SCRW div 2;
 SCR2H:=SCRH div 2;;

end;

procedure DrawTextureBox;
var
rx,ry,dx,dy:single;
spx:array[0..3]of Single;
spy:array[0..3]of Single;
begin
 if Alpha<>255 then glEnable(GL_BLEND);
 glcolor4ub(GetRValue(Color),GetGValue(Color),GetBValue(Color),Alpha);

  glEnable( GL_TEXTURE_2D );
  glPushMatrix();
  glTranslatef(X,Y,0);
  if Angle<>0 then glrotatef(Angle,0,0,1);
  glBindTexture(GL_TEXTURE_2D, textId); // use floor

  spx[0]:=0;
  spx[1]:=1;
  spx[2]:=1;
  spx[3]:=0;

  spy[0]:=1;
  spy[1]:=1;
  spy[2]:=0;
  spy[3]:=0;

 glBegin(GL_QUADS);
 if center then
  begin
          Rx:=W/2;
          Ry:=H/2;
      glTexCoord2f(spx[0],spy[0]);  glVertex2f(-rx,-ry);
      glTexCoord2f(spx[1],spy[1]);  glVertex2f(rx,-ry);
      glTexCoord2f(spx[2],spy[2]);  glVertex2f(rx,ry);
      glTexCoord2f(spx[3],spy[3]);  glVertex2f(-rx,ry);
   end
   else
   begin
      glTexCoord2f(spx[0],spy[0]);  glVertex2f(0, 0);
      glTexCoord2f(spx[1],spy[1]);  glVertex2f(0+w,0);
      glTexCoord2f(spx[2],spy[2]);  glVertex2f(0+w, 0+h);
      glTexCoord2f(spx[3],spy[3]);  glVertex2f(0,0+h);
   end;

  glEnd();
  glPopMatrix();
  if Alpha<>255 then glDisable(GL_BLEND);
  glDisable( GL_TEXTURE_2D );
end;



//   
function IntToStr(x: integer): string;
begin
Str(x, Result);
end;

function StrToInt(const S: string): Integer;
var
  E: Integer;
begin
  Val(S, Result, E);
end;


procedure DrawRectangle2D(X, Y, Width, Height, Color:integer; Alpha : byte=255;Angle:integer=0; Fill : boolean = false;Center:boolean=false);
var
Rx,Ry:real;
begin

glPushMatrix;

glTranslatef(X,Y,0);

if Angle<>0 then glrotatef(Angle,0,0,1);
if Alpha<>255 then glEnable(GL_BLEND);

 if fill then
 begin

  glcolor4ub(GetRValue(Color),GetGValue(Color),GetBValue(Color),Alpha);
   glBegin(GL_QUADS);
  if center then
  begin
      Rx:=Width/2;
      Ry:=Height/2;
    glVertex2f(-rx,-ry);
    glVertex2f(rx,-ry);
    glVertex2f(rx,ry);
    glVertex2f(-rx,ry);
 end
 else
 begin
    glVertex2f(0,0);
    glVertex2f(0+Width,0);
    glVertex2f(0+Width,0+Height);
    glVertex2f(0,0+Height);
 end;

   glEnd;

 end else
 begin

  glcolor4ub(GetRValue(Color),GetGValue(Color),GetBValue(Color),Alpha);
   glBegin(GL_LINE_STRIP);
     if center then
  begin
      Rx:=Width/2;
      Ry:=Height/2;

    glVertex2f(-rx,-ry);
    glVertex2f(rx,-ry);
    glVertex2f(rx,ry);
    glVertex2f(-rx,ry);
    glVertex2f(-rx,-ry);
   end
   else
   begin

    glVertex2f(0,0);
    glVertex2f(0+Width,0);
    glVertex2f(0+Width,0+Height);
    glVertex2f(0,0+Height);
    glVertex2f(0,0-1);

   end;

   glEnd;

 end;
 glPopMatrix;

if Alpha<>255 then glDisable(GL_BLEND);
end;

procedure SText2D(font: DWORD; const str: string; X, Y, color: integer; Alpha : byte); stdcall;
begin
glPushMatrix();

if Alpha<>255 then
  glEnable(GL_BLEND);
 glcolor4ub(GetRValue(Color),GetGValue(Color),GetBValue(Color),Alpha);
 glRasterPos2f(X, Y);
 glListBase(font);
 glCallLists(Length(str), GL_UNSIGNED_BYTE, PChar(str));
if Alpha<>255 then
  glDisable(GL_BLEND);
glPopMatrix();
end;



function CreateSystemFont2D(AD:hDC;Face: PChar; W, H: integer): DWORD; stdcall;
var
 font : HFONT;
begin
Result := glGenLists(256);
font := CreateFont(H, W, 0, 0, 0, 0, 0, 0,RUSSIAN_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS,
                   ANTIALIASED_QUALITY, FW_BOLD {or FF_DONTCARE or DEFAULT_PITCH}, Face);
SelectObject(AD, font);
wglUseFontBitmaps(AD, 0, 256, Result);
DeleteObject(font);
end;


function ExtractFileDir(const FileName: string): string;
var
  I: Integer;
begin
  I := LastDelimiter(PathDelim + DriveDelim,Filename);
  if (I > 1) and (FileName[I] = PathDelim) and
    (((FileName[I - 1] <> PathDelim) and (FileName[I-1] <> DriveDelim)) or
    (ByteType(FileName, I-1) = mbTrailByte)) then Dec(I);
  while (ByteType(FileName, I-1) = mbTrailByte) and (I > 0) do Dec(I);
  Result := Copy(FileName, 1, I);
end;


function GetTimer: integer;
var
T : LARGE_INTEGER;
F : LARGE_INTEGER;
begin
QueryPerformanceFrequency(Int64(F));
QueryPerformanceCounter(Int64(T));
result := round(1000 * T.QuadPart / F.QuadPart);
end;



procedure FreeSystemFont2D(font: DWORD); stdcall;
begin
glDeleteLists(font, 256);
end;


procedure VBL2(vsync : TVSyncMode);
var
   i : Integer;
begin
   if WGL_EXT_swap_control then
   begin
      i := wglGetSwapIntervalEXT;
      case VSync of
         vsmSync    : if i<>1 then wglSwapIntervalEXT(1);
         vsmNoSync  : if i<>0 then wglSwapIntervalEXT(0);
      else
         Assert(False);
      end;
   end;

end;


//   //
procedure glBlend(ID: Byte);
begin
if ID = 0 then
 glDisable(GL_BLEND)
else
 begin
 glEnable(GL_BLEND);
  case ID of
   1 : glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
   2 : glBlendFunc(GL_SRC_ALPHA, GL_ONE);
   3 : glBlendFunc(GL_ZERO, GL_SRC_COLOR);
  end;
 end;
end;

procedure Enable2d(A:boolean);
begin
 if A then
 begin
  glDisable(GL_DEPTH_TEST);
  glMatrixMode(GL_PROJECTION);
  glPushMatrix;
  glLoadIdentity;
  gluOrtho2D(0,SCRW,SCRH,0);
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix;
  glLoadIdentity;
 end
 else
 begin
   glPopMatrix;
  glMatrixMode(GL_PROJECTION);
  glPopMatrix;
  glMatrixMode(GL_MODELVIEW);
  glEnable(GL_DEPTH_TEST);
 end;

 end;



end.
