program Train_A22;

uses
  zglHeader,
  u_Init in 'u_Init.pas',
  u_Game in 'u_Game.pas',
  u_Menu in 'u_Menu.pas';

  procedure Main;
  begin
    mX := Mouse_X;
    my := Mouse_Y;
    case Scene of
      sMenu : Menu_Process;
      sGame : Game_Process;
      sLogo : Logo_Process;
      sTop  : Top_Process;
    end;
    key_ClearState;
    mouse_ClearState;
    //wnd_SetCaption( 'FPS: '+U_IntToStr(zgl_Get(SYS_FPS)) );
  end;

  procedure Init;
  begin
    LevelX := 40;
    MinesCount := 10;
    Scene := sLogo;
    AllInit;
  end;

  procedure Paint;
  begin
    batch2d_Begin;
    case Scene of
      sMenu : Menu_Paint;
      sGame : Game_Paint;
      sLogo : Logo_Paint;
      sTop  : Top_Paint;
    end;
    batch2d_End;
    //text_Draw( Font, 10, 200, 'FPS: '+U_IntToStr(zgl_Get(SYS_FPS)) );
  end;

  procedure Exit;
  begin
    Save_Top;
  end;

  begin
    zglLoad('ZenGL.dll');
    Main_Timer := timer_Add(@Main, 10);
    Move_Timer := timer_Add(@Move, 20);
    zgl_Reg(SYS_DRAW, @Paint);
    zgl_Reg(SYS_EXIT, @Exit);
    zgl_Reg(SYS_LOAD, @Init);
    zgl_Reg(SYS_ACTIVATE, @isPause);
    zgl_Enable(WND_USE_AUTOCENTER);
    scr_SetOptions(640, 480, 32, 0, FALSE, FALSE);
    wnd_ShowCursor(TRUE);
    zgl_Disable(APP_USE_AUTOPAUSE);
    zgl_Init;
  end.
