unit u_Game;

interface
uses
  zglHeader;

type
  TScene = ( sGame, sMenu, sLogo, sTop );

type
  TBrick = record
    X, Y: Single;
    BrickType, Flags, RoadType, NextRoad: Byte;
    FlagCount, Number, Land: Integer;
    Rect: zglTRect;
    Open, Flag, Road, Down, Mine, Scored,
    SetHero, Bonus, Boom: Boolean;
  end;

type
  THistory = record
    X, Y, Angle: Single;
  end;

type
  THero = record
    History: array[0..1600]of THistory;
    X, Y, Angle, TargetAngle, Test: Single;
    Dir: Integer;
    Rect: zglTRect;
  end;

type
  TFlag = record
    X, Y: Integer;
    Done, Active: Boolean;
  end;

var
  Hero: THero;
  Camera : zglTCamera2d;
  Ololo: array[0..100] of TFlag;
  Field: array[0..151, 0..11] of TBrick;
  Bricks, Road, Land1, Train, Cursor, BonusTex, Explosion: zglPTexture;
  Speed1, Speed2, CameraTarget, CamX, CamY: Single;
  Flags, NowFlags, Delay, SmallFlags,
  ScoreBricks, Score, Bonuses, BoomAlpha, BoomDir, Delay2: Integer;
  TilesBricks, TilesBack: zglTTiles2D;
  Scene: TScene;
  mX, mY: Single;

  Test1, Test2, Test3, Test4, Test5, Test6: zglPTexture;

  Music : zglPSound;
  Win, Lose, Scroll, Add, Add2, Paused: Boolean;
  Main_Timer, Move_Timer: zglPTimer;
  procedure Game_Process;
  procedure Game_Paint;
  procedure Add_Top;
  function CalcM( I, J: Integer ) : Integer;
  function CalcF( I, J: Integer ) : Integer;
  function ChoseDir( RoadType: Integer ) : Integer;
  function ChoseAngle( RoadType: Integer ) : Single;
  procedure Move;

implementation
uses
  u_Init, u_Menu;

procedure Move;
begin

end;

procedure Add_Top;
var
i, j: integer;
begin
  //if Score > top[0].Score then
  //begin
  //  top[0].Nick := '';
  //  key_BeginReadText( top[0].Nick, 20 );
  //  top[0].Score := Score;
  //  top[0].Enter := True;
  //end;
  for i := 0 to 4 do
  begin
    if (Score > top[i].Score) and (Score < top[i-1].Score) then
    begin
      for j := 0 to 4 do
      begin
        if j < 4-i then
        begin
          top[4-j] := top[4-j-1];
        end;
      end;
      top[i].Nick := '';
      key_BeginReadText( top[i].Nick, 10 );
      top[i].Score := Score;
      top[i].Enter := True;
    end;
  end;
end;

function ChoseDir( RoadType: Integer ) : Integer;
begin
  Result := 1;
  case RoadType of
    1 : Result := Hero.Dir;
    2 : Result := 3;
    3 : Result := 4;
    4 : Result := 2;
    5 : Result := 3;
    6 : Result := 3;
  end;
end;

function ChoseAngle( RoadType: Integer ) : Single;
begin
  Result := 1;
  case RoadType of
    1 : Result := Hero.TargetAngle;
    2 : Result := 0;
    3 : Result := 90;
    4 : Result := 270;
    5 : Result := 0;
    6 : Result := 0;
  end;
end;

function CalcM( I, J: Integer ) : Integer;
begin
  Result := 0;
  if Field[i-1,j-1].BrickType = 10 then Result := Result + 1;
  if Field[i-1,j].BrickType = 10 then Result := Result + 1;
  if Field[i-1,j+1].BrickType = 10 then Result := Result + 1;
  if Field[i,j+1].BrickType = 10 then Result := Result + 1;
  if Field[i+1,j+1].BrickType = 10 then Result := Result + 1;
  if Field[i+1,j].BrickType = 10 then Result := Result + 1;
  if Field[i+1,j-1].BrickType = 10 then Result := Result + 1;
  if Field[i,j-1].BrickType = 10 then Result := Result + 1;
end;

function CalcF( I, J: Integer ) : Integer;
begin
  Result := 0;
  if Field[i-1,j-1].Flag then Result := Result + 1;
  if Field[i-1,j].Flag then Result := Result + 1;
  if Field[i-1,j+1].Flag then Result := Result + 1;
  if Field[i,j+1].Flag then Result := Result + 1;
  if Field[i+1,j+1].Flag then Result := Result + 1;
  if Field[i+1,j].Flag then Result := Result + 1;
  if Field[i+1,j-1].Flag then Result := Result + 1;
  if Field[i,j-1].Flag then Result := Result + 1;
end;

procedure Game_Process;
var
i, j, f, k, l: integer;
begin
  //if key_Press( K_SPACE ) then
  //begin
  // rest;
  // road_gen;
  // set_hero;
  //end;


  if BoomDir = 1 then BoomAlpha := BoomAlpha + 15;
  if BoomAlpha = 255 then BoomDir := 2;
  if (BoomDir = 2) and (BoomAlpha > 0) then BoomAlpha := BoomAlpha - 5;


  for i := 1 to LevelX do
  for j := 1 to 10 do
  begin
    if Field[i,j].Open and Field[i,j].Mine then
    begin
      //Lose := True;
      //Scene := sMenu;
      //BContinue.Disable := True;
      //BRecords.Press := True;
      //ScoresState.Alpha := 255;
      //Camera.X := 0;
      //Camera.Y := 0;
      //Add_Top;



      if Bonuses = -1 then
      begin
        Lose := True;
        Scene := sMenu;
        BContinue.Disable := True;
        BRecords.Press := True;
        ScoresState.Alpha := 255;
        Camera.X := 0;
        Camera.Y := 0;
        Add_Top;
      end;

      if not Field[i,j].Boom then
      begin
        Bonuses := Bonuses - 1;
        BoomAlpha := 15;
        BoomDir := 1;
        Field[i,j].Boom := True;
      end;
    end;
    // SCORE
    if Field[i,j].Open then
    begin
      if not Field[i,j].Scored then
      begin
        Score := Score + 3 * Bonuses;
      end;
      Field[i,j].Scored := True;
    end;
    // SCORE

    //BONUS
    if Field[i,j].Open then
    begin
      if Field[i,j].Bonus then
      begin
        Bonuses := Bonuses + 1;
        Field[i,j].Bonus := False;
      end;
    end;
    //BONUS

    if col2d_Rect( Field[i,j].Rect, Hero.Rect ) then
    begin
      //if not Field[i,j].Flag and not Field[i,j].Open
      //then Field[i,j].Open := True;
      if Field[i,j].Road then Field[i,j].Open := True;
    end;

    if Field[i,j].RoadType > 0 then
    begin
      //if (Round(Hero.X) = Field[i,j].X)
      //and (Round(Hero.Y) = Field[i,j].Y) then
      if col2d_RectInRect(Hero.Rect, Field[i,j].Rect ) then
      begin
        if not Field[i,j].SetHero then
        begin
          Hero.X := Field[i,j].x;
          Hero.Y := Field[i,j].y;
          Hero.Rect.x := Hero.X + 1;
          Hero.Rect.y := Hero.Y + 1;
          Hero.Dir := ChoseDir( Field[i,j].NextRoad);
          Hero.TargetAngle := ChoseAngle( Field[i,j].NextRoad );
          case Hero.Dir of
            1 : Hero.X := Hero.X + 0.72; // 0.25
            2 : Hero.Y := Hero.Y + 1;
            3 : Hero.X := Hero.X - 0.72;
            4 : Hero.Y := Hero.Y - 1;
          end;
          if Field[i,j].NextRoad = 3 then Hero.Y := Hero.Y + 1;
          if Field[i,j].NextRoad = 4 then Hero.Y := Hero.Y - 1;

          if (Field[i,j].RoadType = 1) and (Field[i,j].NextRoad = 5)
          then Hero.X := Hero.X + 1;

          if (Field[i,j].RoadType = 1) and (Field[i,j].NextRoad = 6)
          then Hero.X := Hero.X + 1;

          Field[i,j].SetHero := True;
        end;
        //Hero.Dir := ChoseDir( Field[i,j].NextRoad );
        //Hero.TargetAngle := ChoseAngle( Field[i,j].NextRoad );
      end;
    end;

    Field[i,j].Flags := CalcF(I, J);

    if not col2d_PointInRect( Camera.X + mX, Camera.Y + mY, Field[i,j].Rect )
    then Field[i,j].Down := False;

    if col2d_PointInRect( Camera.X + mX, Camera.Y + mY, Field[i,j].Rect ) then
    begin
      if mouse_Down( M_BLEFT ) and not Scroll then
      begin
        //if not Field[i,j].Flag then
        Field[i,j].Down := True;
      end;
      if mouse_Up(M_BLEFT) and not Scroll then
      begin
        if Field[i,j].Down then
        begin
          Field[i,j].Open := True;
          Field[i,j].FlagCount := 200;
          //if Field[i,j].Flag then
          //begin
          //  Field[i,j].Down := False;
          //  Field[i,j].Flag := False;
          //end else Field[i,j].Open := True;
        end;
      end;
      if mouse_Click(M_BRIGHT) and not Scroll then
      begin
        if not Field[i,j].Open then
        begin
          //if Field[i,j].Flag then NowFlags := NowFlags + 1;
          //if not Field[i,j].Flag then Flags := Flags + 1;
          Flags := Flags + 1;
          if Field[i,j].Flag then Field[i,j].Flag := False
          else Field[i,j].Flag := true;
          if (Field[i,j].FlagCount > 0) then Field[i,j].FlagCount := 0
          else Field[i,j].FlagCount := 1;
          Field[i,j].Number := Flags;
        end;
      end;
      if mouse_DblClick(M_BLEFT) and not Scroll then
      begin
        if (Field[i,j].BrickType < 10)
        and (Field[i,j].BrickType > 0)
        and (Field[i,j].BrickType <= Field[i,j].Flags) then
        begin
          if col2d_PointInRect( Camera.X + mX, Camera.Y + mY, Field[i,j].Rect ) then
          begin
            if not Field[i-1,j-1].Flag then Field[i-1,j-1].Open := true;
            if not Field[i-1,j].Flag then Field[i-1,j].Open := true;
            if not Field[i-1,j+1].Flag then Field[i-1,j+1].Open := true;
            if not Field[i,j+1].Flag then Field[i,j+1].Open := true;
            if not Field[i+1,j+1].Flag then Field[i+1,j+1].Open := true;
            if not Field[i+1,j].Flag then Field[i+1,j].Open := true;
            if not Field[i+1,j-1].Flag then Field[i+1,j-1].Open := true;
            if not Field[i,j-1].Flag then Field[i,j-1].Open := true;
          end;
        end;
      end;
    end;


    if (Field[i,j].Number = NowFlags) then
    begin
      //if not Field[i,j].Flag then NowFlags := NowFlags + 1;
      if Field[i,j].Flag then
      begin
        if not Scroll then
        begin
          Field[i,j].FlagCount := Field[i,j].FlagCount + 1;
          if Field[i,j].FlagCount = 160 then
          begin
            if not Field[i,j].Open then
            begin
              Field[i,j].Open := True;
              Field[i,j].Mine := False;
            end;
            //NowFlags := NowFlags + 1;
          end;
        end;
      end;
    end;

    if Field[i,j].Flag and not Field[i,j].Open then
    begin
      SmallFlags := 1000000000;
      Add2 := True;
      for k := 1 to 150 do
      for l := 1 to 10 do
      begin
        if (Field[k,l].Number > 0) and (Field[k,l].Number < SmallFlags)
        and not Field[k,l].Open and Field[k,l].Flag then SmallFlags := Field[k,l].Number;
        //if (Field[k,l].Number = NowFlags) then Add2 := False;
      end;
      if Add2 then NowFlags := SmallFlags;
    end;


    if Field[i,j].BrickType <> 10 then
    Field[i,j].BrickType := CalcM(I, J)
    else Field[i,j].BrickType := 10;

    if Field[i,j].BrickType <> 10 then
    begin
      if ((Field[i-1,j].BrickType = 0) and Field[i-1,j].Open)
      or ((Field[i+1,j].BrickType = 0) and Field[i+1,j].Open)
      or ((Field[i,j-1].BrickType = 0) and Field[i,j-1].Open)
      or ((Field[i,j+1].BrickType = 0) and Field[i,j+1].Open)
      or ((Field[i+1,j+1].BrickType = 0) and Field[i+1,j+1].Open)
      or ((Field[i+1,j-1].BrickType = 0) and Field[i+1,j-1].Open)
      or ((Field[i-1,j+1].BrickType = 0) and Field[i-1,j+1].Open)
      or ((Field[i-1,j-1].BrickType = 0) and Field[i-1,j-1].Open)
      then
      begin
        if  Field[i,j].Flag = False then Field[i,j].Open := True;
      end;
    end;

    //if (Field[i,j].BrickType = 10) and Field[i,j].Open then Lose := true;

    {if Field[i,j].Flag then Flags := Flags + 1;
    if Flags = 8 then
    begin
      for k := 1 to 150 do
      for l := 1 to 10 do
      begin
        if Field[k,l].Flag and (Field[k,l].BrickType <> 10) then
        Win := False else Win := True;
      end;
    end;}
  end;

  //Flags := 0;

  if not Scroll then AspireAngle(Hero.Angle, Hero.TargetAngle, 0.53);
  if not Scroll then AspireAngle(Hero.Test, Hero.TargetAngle, 0.5);

  //Camera.X := Hero.X;
  if not Scroll then
  begin
  {case Hero.Dir of
    1 : Hero.X := Hero.X - 0.06; // 0.25
    2 : Hero.Y := Hero.Y - 0.06;
    3 : Hero.X := Hero.X + 0.06;
    4 : Hero.Y := Hero.Y + 0.06;
  end;}
  Hero.X := Hero.X + M_Cos(Round(Hero.Test))*0.208;
  Hero.Y := Hero.Y + M_Sin(Round(Hero.Test))*0.208;
  Hero.Rect.X := Hero.X + 1;
  Hero.Rect.Y := Hero.Y + 1;
  end;

  Delay := Delay + 1;
  if Delay = 1 then
  begin
    if not Scroll then
    begin
      for k := 0 to 1599 do
      begin
        Hero.History[k] := Hero.History[k+1];
      end;
      Hero.History[1600].X := Hero.X;
      Hero.History[1600].Y := Hero.Y;
      Hero.History[1600].Angle := Hero.Angle;
    end;
    Delay := 0;
  end;

  {if ((Hero.X - Camera.X) >= 320) then Scroll := True;
  if Scroll then
  begin
    SqrAspire(Camera.X, Camera.X + 300, Speed1);
    Aspire(Camera.X, Camera.X + 300 , Speed2);
    if ((Hero.X) < Camera.X) then Scroll := False;
  end;}

  if ((Hero.X - Camera.X) >= 310) then
  begin
    if ((Camera.X + 216+640) < field[LevelX,1].X + 24) then
    begin
    if not Scroll then CameraTarget := Camera.X + 216;
    Scroll := True;
    end;
  end;

  if Scroll then
  begin
    SqrAspire(Camera.X, CameraTarget, Speed1);
    if Aspire(Camera.X, CameraTarget, Speed2) then
    Scroll := False;
  end;

  //if Key_Press ( K_F1 ) then Speed1 := Speed1 + 0.0001;
  //if Key_Press ( K_F2 ) then Speed1 := Speed1 - 0.0001;
  //if Key_Press ( K_F3 ) then Speed2 := Speed2 + 0.0001;
  //if Key_Press ( K_F4 ) then Speed2 := Speed2 - 0.0001;

  if key_Press (K_ESCAPE) Then
  begin
    Paused := True;
    Bcontinue.Disable := False;
    Scene := sMenu;
    CamX := Camera.X;
    CamY := Camera.Y;
    Camera.X := 0;
    Camera.Y := 0;
  end;


  Delay2 := Delay2 + 1;
  if Delay2 = 5 then
  begin
  if not isBonused then
  begin
    SetBonuses(BonusesCount);
    isBonused := True;
  end;
  end;


  if Hero.Rect.x > Field[LevelX,1].X +24 then
  begin
    Win := True;
    Scene := sMenu;
    BContinue.Disable := True;
    BRecords.Press := True;
    ScoresState.Alpha := 255;
    Camera.X := 0;
    Camera.Y := 0;
    Add_Top;
  end;
end;

procedure Game_Paint;
var
i, j: Integer;
begin
  //if zgl_Get(APP_PAUSED) <> 0 Then
  //begin
  //  Paused := True;
  //  Bcontinue.Disable := False;
  //  Scene := sMenu;
  //end;
  tiles2d_Draw( Land1, 0, 120, TilesBricks, 255 );

  for i := 1 to LevelX do
  for j := 1 to 10 do
  begin
    if (Field[i,j].X > (Camera.X-40))
    and (Field[i,j].X < (Camera.X+680)) then
    begin
      if Field[i,j].Road then
      begin
        if Field[i,j].RoadType = 2 then
        asprite2d_Draw( Road, Field[i,j].X, Field[i,j].Y, 24, 24, 0, Field[i,j].RoadType, 255 );

        if Field[i,j].RoadType = 1 then
        asprite2d_Draw( Road, Field[i,j].X, Field[i,j].Y, 24, 24, 90, Field[i,j].RoadType, 255 );

        if Field[i,j].RoadType = 6 then
        ssprite2d_Draw( Test3, Field[i,j].X, Field[i,j].Y-16, 40, 40, 0, 255 );

        if Field[i,j].RoadType = 5 then
        ssprite2d_Draw( Test3, Field[i,j].X, Field[i,j].Y, 40, 40, 90, 255 );

        if Field[i,j].RoadType = 3 then
        ssprite2d_Draw( Test3, Field[i,j].X-16, Field[i,j].Y, 40, 40, 180, 255 );

        if Field[i,j].RoadType = 4 then
        ssprite2d_Draw( Test3, Field[i,j].X-16, Field[i,j].Y-16, 40, 40, 270, 255 );
      end;
    end;
  end;


  for i := 1 to LevelX do
  for j := 1 to 10 do
  begin
    if (Field[i,j].X > (Camera.X-40))
    and (Field[i,j].X < (Camera.X+680)) then
    begin
      //asprite2d_Draw( Land1, Field[i,j].X, Field[i,j].Y, 25, 24, 0, Field[i,j].Land );
      //tiles2d_Draw( Land1, 0, 100, TilesBricks, 255 );

      if not Field[i,j].Open then
      begin
        if not Field[i,j].Down then
        asprite2d_Draw( Bricks, Field[i,j].X, Field[i,j].Y, 24, 24, 0, 1 );
      end
      else
      begin
        if (Field[i,j].BrickType > 0) and (Field[i,j].BrickType < 10) then
        asprite2d_Draw( Bricks, Field[i,j].X, Field[i,j].Y, 24, 24, 0, Field[i,j].BrickType + 1 );
        if (Field[i,j].BrickType = 10) and not Field[i,j].Mine then
        asprite2d_Draw( Bricks, Field[i,j].X, Field[i,j].Y, 24, 24, 0, 11 );
      end;

      if Field[i,j].Bonus then
      ssprite2d_Draw( BonusTex, Field[i,j].X, Field[i,j].Y, 24, 24, 0, 255 );

      //if Field[i,j].Open and Field[i,j].Mine then
      //begin
      //  pr2d_Circle( Field[i,j].X+12, Field[i,j].Y+12, 7, $FF0000, 255, 32, PR2D_FILL );
      //end;

      if Field[i,j].Open and Field[i,j].Mine and Field[i,j].Boom then
      begin
        ssprite2d_Draw( Explosion, Field[i,j].X-12, Field[i,j].Y-12, 48, 48, 0 );
      end;

      if Field[i,j].Flag and not Field[i,j].Open then
      asprite2d_Draw( Bricks, Field[i,j].X, Field[i,j].Y, 24, 24, 0, 10 );

      if Field[i,j].Flag and not Field[i,j].Open and( Field[i,j].FlagCount > 1) and (Field[i,j].FlagCount < 160) then
      pr2d_Rect(Field[i,j].X+2, Field[i,j].Y+2, Field[i,j].FlagCount / 8, 20, $FFFFFF, 155, PR2D_FILL );

      //text_DrawEx( Font, Field[i,j].X, Field[i,j].Y, 0.6, 1, U_IntToStr(Field[i,j].NextRoad) );
    end;
  end;
  //Pr2D_TRect( @Hero.Rect, $FFFFFF );
  //ssprite2d_Draw( Train, Hero.History[600].X-12, Hero.History[600].Y-12, 48, 48, Hero.History[600].Angle );
  //ssprite2d_Draw( Train, Hero.History[800].X-12, Hero.History[800].Y-12, 48, 48, Hero.History[800].Angle );

  //ssprite2d_Draw( Test1, Hero.History[600].X-12, Hero.History[600].Y-12, 48, 48, Hero.History[600].Angle );
  //ssprite2d_Draw( Test1, Hero.History[800].X-12, Hero.History[800].Y-12, 48, 48, Hero.History[800].Angle );

  for i := 1 to Bonuses do
  begin
    ssprite2d_Draw( Test1, Hero.History[1600-200*(Bonuses-i+1)].X-12, Hero.History[1600-200*(Bonuses-i+1)].Y-12, 48, 48, Hero.History[1600-200*(Bonuses-i+1)].Angle );
  end;

  ssprite2d_Draw( Train, Hero.X-12, Hero.Y-12, 48, 48, Hero.Angle );
  //text_DrawEx( Font, Camera.X + 10, 10, 0.6, 1, 'Space - Restart' );
  //pr2d_Rect( hero.Rect.x, hero.Rect.y, hero.Rect.w, hero.Rect.h, $FF0000 );
  text_DrawEx( Font, Camera.X + 10, 10, 1, 1, 'Score: '+U_IntToStr(Score) );
  (*Text_Draw( Font, Camera.X + 10, 10, PChar(String('Space - Restart')), 0.5 );
  Text_Draw( Font, Camera.X + 10, 30, PChar(String('Score: ')+U_IntToStr(Score)), 0.5 );*)
  //Text_Draw( Font, Camera.X + 10, 30, PChar(String('FPS: '+U_IntToStr(OE_GETFPS))), 0.5 );
  //Text_Draw( Font, Camera.X + 10, 400, PChar(String('Speed1: '+U_FloatToStr(NowFlags))), 0.5 );
  //Text_Draw( Font, Camera.X + 10, 420, PChar(String('Speed2: '+U_FloatToStr(SmallFlags))), 0.5 );
  //if Lose then Text_Draw( Font, Camera.X + 10, 30, PChar(String('You Lose :(')), 0.5 );
  //if Win then Text_Draw( Font, 10, 30, PChar(String('You Win :)')), 0.5 );
  //ssprite2d_Draw( Cursor, Camera.X + mX, Camera.Y + mY, 50, 50, 0 );
  pr2d_Rect( Camera.X, Camera.Y, 640, 480, $FFFFFF, BoomAlpha, PR2D_FILL );
end;

end.

