unit u_Menu;

interface
uses
  zglHeader, windows;

type
  PButton = ^TButton;
  TButton = record
    Rect: zglTRect;
    C: zglTCircle;
    Visible, Disable, Mouse, Press, Down: Boolean;
    Frame: Byte;
    Text: String[20];
  end;

type
  TTopLine = record
    Nick: String;
    Score: Integer;
    Enter: Boolean;
    W : Single;
  end;

type
  TAboutLine = record
    Text: String;
    W, S, X: Single;
  end;

type
  TMenuState = record
    Show: Boolean;
    Alpha: Single;
  end;

var
  About: array[0..6] of TAboutLine;
  Top: array[0..4] of TTopLine;
  Logo, ButtonTex, ButtonSmallTex, Head, GameLogo, Back: zglPTexture;
  Font: zglPFont;
  NewGameState, CreditsState, ScoresState: TMenuState;
  Logo_count, Logo_alpha, Black_alpha: Single;
  BNewGame, BContinue, BRecords, BQuit, BBack,
  BCredits, BLevel1, BLevel2, BLevel3: TButton;
  lineAlpha: Byte;
  procedure Menu_Process;
  procedure Logo_Process;
  procedure Top_Process;
  procedure Menu_Paint;
  procedure Logo_Paint;
  procedure Top_Paint;
  function Aspire(var s : single; aim, speed : single) : boolean;
  function SqrAspire(var s : single; aim, speed : single) : boolean;
  procedure NormalizeAngle(var angle : single);
  function AspireAngle(var s : single; aim, speed : single) : boolean;
  procedure Button_Process( Button: PButton );
  procedure Button_Paint( Button: PButton );
  procedure SmallButton_Paint( Button: PButton );
  procedure Save_Top;
  procedure Load_Top;
  procedure isPause( Activate : Boolean );

implementation
uses
  u_Game, u_Init;

procedure isPause( Activate : Boolean );
begin
 if (not Activate) and (Scene = sGame) then
  begin
    Paused := True;
    Bcontinue.Disable := False;
    Scene := sMenu;
    CamX := Camera.X;
    CamY := Camera.Y;
    Camera.X := 0;
    Camera.Y := 0;
  end;
end;

procedure Save_Top;
var
f: TextFile;
i: integer;
begin
  for i := 0 to 4 do
  if top[i].Enter then
  begin
    if top[i].Enter then
    begin
      top[i].Enter := False;
      top[i].Nick := top[i].nick + #0;
    end;
  end;
  AssignFile(f, 'top.txt');;
  ReWrite(f);
  for i := 0 to 4 do
  begin
    if top[i].Nick[Length(top[i].Nick)] = #0 Then
    SetLength(top[i].Nick, Length(top[i].Nick)-1);
    WriteLn(f, top[i].Nick);
    WriteLn(f, top[i].Score);
  end;
  closefile(f);
end;

procedure Load_Top;
var
f: TextFile;
i: Integer;
begin
  AssignFile(f, 'top.txt');;
  reset(f);
  for i := 0 to 4 do
  begin
    ReadLn(f, top[i].Nick);
    ReadLn(f, top[i].Score);
  end;
  closefile(f);
end;

procedure Button_Process( Button: PButton );
begin
  if Button.Visible then
  begin
    if col2d_PointInCircle( Mouse_X, Mouse_Y, Button.C ) then
    Button.Mouse := True else Button.Mouse := False;
    if col2d_PointInCircle( Mouse_X, Mouse_Y, Button.C ) and mouse_Up(M_BLEFT) then
    begin
      if Button.Press then Button.Press := False else Button.Press := True;
    end;
    if col2d_PointInCircle( Mouse_X, Mouse_Y, Button.C ) and mouse_Down(M_BLEFT) then
    Button.Down := True else Button.Down := False;
    if Button.Down then Button.Frame := 3 else Button.Frame := 1;
  end;
end;

procedure Button_Paint( Button: PButton );
begin
  if Button.Visible and not Button.Disable then
  begin
    if not Button.Mouse then asprite2d_Draw( ButtonTex, Button.Rect.x-2, Button.Rect.y-4, 100, 100, 0, Button.Frame, 255 );
    if Button.Down then asprite2d_Draw( ButtonTex, Button.Rect.x-2, Button.Rect.y-4, 100, 100, 0, Button.Frame, 255 );
    text_DrawInRectEx( Font, Button.Rect, 0.8, 1, Button.Text, 255, $FFFFFF, TEXT_HALIGN_CENTER or TEXT_VALIGN_CENTER );
    if Button.Mouse and not Button.Down then asprite2d_Draw( ButtonTex, Button.Rect.x-2, Button.Rect.y-4, 100, 100, 0, 2, 255 );
    //if Button.Mouse and not Button.Disable then pr2d_Rect( Button.Rect.x, Button.Rect.y, 100, 100, $FFFFFF, 100, PR2D_FILL );
    //if Button.Disable then pr2d_Rect( Button.Rect.x, Button.Rect.y, 100, 100, $000000, 100, PR2D_FILL );
  end;
  if Button.Visible and Button.Disable then
  begin
    asprite2d_Draw( ButtonTex, Button.Rect.x-2, Button.Rect.y-4, 100, 100, 0, 1, 130 );
    text_DrawInRectEx( Font, Button.Rect, 0.8, 1, Button.Text, 130, $FFFFFF, TEXT_HALIGN_CENTER or TEXT_VALIGN_CENTER );
  end;
end;

procedure SmallButton_Paint( Button: PButton );
begin
  if Button.Visible and not Button.Disable then
  begin
    if not Button.Mouse then asprite2d_Draw( ButtonSmallTex, Button.Rect.x-3, Button.Rect.y-5, 40, 40, 0, Button.Frame, Round(NewGameState.Alpha) );
    if Button.Down then asprite2d_Draw( ButtonSmallTex, Button.Rect.x-3, Button.Rect.y-5, 40, 40, 0, Button.Frame, Round(NewGameState.Alpha) );
    text_DrawInRectEx( Font, Button.Rect, 0.8, 1, Button.Text, Round(NewGameState.Alpha), $FFFFFF, TEXT_HALIGN_CENTER or TEXT_VALIGN_CENTER );
    if Button.Mouse and not Button.Down then asprite2d_Draw( ButtonSmallTex, Button.Rect.x-3, Button.Rect.y-5, 40, 40, 0, 2, Round(NewGameState.Alpha) );
  end;
  if Button.Visible and Button.Disable then
  begin
    asprite2d_Draw( ButtonSmallTex, Button.Rect.x-3, Button.Rect.y-5, 40, 40, 0, 1, Round(NewGameState.Alpha/2) );
    text_DrawInRectEx( Font, Button.Rect, 0.8, 1, Button.Text, Round(NewGameState.Alpha/2), $FFFFFF, TEXT_HALIGN_CENTER or TEXT_VALIGN_CENTER );
  end;
end;

procedure NormalizeAngle(var angle : single);
begin
  if angle < -180 then
  angle :=  360 + angle
  else
  if angle > 180 then
  angle := angle - 360;
end;

function AspireAngle(var s : single; aim, speed : single) : boolean;
var
aim2, aim3 : single;
begin
  aim2 := aim + 360;
  aim3 := aim - 360;
  if (abs(aim2 - s) < abs(aim - s)) and (abs(aim2 - s) < abs(aim3 - s)) then
  aim := aim2
  else
  if (abs(aim3 - s) < abs(aim - s)) and (abs(aim3 - s) < abs(aim2 - s)) then
  aim := aim3;

  //delta  := abs(aim - s);
  result := Aspire(s, aim, speed);
end;


function Aspire(var s : single; aim, speed : single) : boolean;
var
b : boolean;
begin
  b := true;

  if (s + speed < aim) then begin s := s + speed; b := false; end;
  if (s - speed > aim) then begin s := s - speed; b := false; end;

  if b then s := aim;

  result := b;
end;

function SqrAspire(var s : single; aim, speed : single) : boolean;
begin
  result := Aspire(s, aim, speed * (abs(s - aim)));
end;

procedure Logo_Process;
var
r: integer;
begin
  logo_count := logo_count - 1;
  if logo_count <= 0 then Scene := sMenu;
  if key_Press( K_SPACE ) then Scene := sMenu;
  if key_Press( K_ENTER ) then Scene := sMenu;
  if key_Press( K_ESCAPE ) then Scene := sMenu;
  if mouse_Up( M_BLEFT ) then Scene := sMenu;
end;

procedure Logo_Paint;
begin
  ssprite2d_Draw( Logo, 120, 40, 400, 400, 0 );
end;

procedure Menu_Process;
var
i,j: Integer;
begin
  if BNewGame.Press then NewGameState.Show := True else NewGameState.Show := False;
  if BRecords.Press then ScoresState.Show := True else ScoresState.Show := False;
  if BCredits.Press then CreditsState.Show := True else CreditsState.Show := False;
  if NewGameState.Show and (NewGameState.Alpha < 255) then NewGameState.Alpha := NewGameState.Alpha + 5;
  if ScoresState.Show and (ScoresState.Alpha < 255) then ScoresState.Alpha := ScoresState.Alpha + 5;
  if CreditsState.Show and (CreditsState.Alpha < 255) then CreditsState.Alpha := CreditsState.Alpha + 5;
  if not NewGameState.Show and (NewGameState.Alpha > 0) then NewGameState.Alpha := NewGameState.Alpha - 5;
  if not ScoresState.Show and (ScoresState.Alpha > 0) then ScoresState.Alpha := ScoresState.Alpha - 5;
  if not CreditsState.Show and (CreditsState.Alpha > 0) then CreditsState.Alpha := CreditsState.Alpha - 5;
  Button_Process( @BNewGame );
  Button_Process( @BContinue );
  Button_Process( @BRecords );
  Button_Process( @BQuit );
  Button_Process( @BCredits );
  Button_Process( @BLevel3 );
  Button_Process( @BLevel2 );
  Button_Process( @BLevel1 );
  if mouse_Up( M_BLEFT ) then
  begin
    for i := 0 to 4 do
    if top[i].Enter then
    begin
      if top[i].Enter then
      begin
        top[i].Enter := False;
        top[i].Nick := top[i].nick + #0;
      end;
    end;
    if BLevel1.Mouse then
    begin
      if NewGameState.Alpha = 255 then
      begin
        rest;
        road_gen;
        set_hero;
        Scene := sGame;
        BNewGame.Press := False;
        NewGameState.Alpha := 0;
      end;
    end;
    if BLevel2.Mouse then
    begin
      if NewGameState.Alpha = 255 then
      begin
        rest;
        road_gen;
        set_hero;
        Scene := sGame;
        BNewGame.Press := False;
        NewGameState.Alpha := 0;
      end;
    end;
    if BLevel3.Mouse then
    begin
      if NewGameState.Alpha = 255 then
      begin
        rest;
        road_gen;
        set_hero;
        Scene := sGame;
        BNewGame.Press := False;
        NewGameState.Alpha := 0;
      end;
    end;
    if BNewGame.Mouse then
    begin
      //rest;
      //road_gen;
      //set_hero;
      //Scene := sGame;
      BRecords.Press := False;
      BCredits.Press := False;
    end;
    if BContinue.Mouse then
    begin
      if Paused then Scene := sGame;
      Paused := False;
      Bcontinue.Disable := True;
      Camera.X := CamX;
      Camera.Y := CamY;
    end;
    if BRecords.Mouse then
    begin
      //Scene := sTop;
      BNewGame.Press := False;
      BCredits.Press := False;
    end;
    if BCredits.Mouse then
    begin
      //Scene := sTop;
      BNewGame.Press := False;
      BRecords.Press := False;
    end;
    if BQuit.Mouse then
    begin
      zgl_Exit;
    end;
    if BLevel1.Mouse then
    begin
      LevelX := 45;
      MinesCount := 30;
      BonusesCount := 5;
      rest;
      road_gen;
      set_hero;
    end;
    if BLevel2.Mouse then
    begin
      LevelX := 45;
      MinesCount := 50;
      BonusesCount := 3;
      rest;
      road_gen;
      set_hero;
    end;
    if BLevel3.Mouse then
    begin
      LevelX := 83;
      MinesCount := 120;
      BonusesCount := 5;
      rest;
      road_gen;
      set_hero;
    end;
  end;

  for i := 0 to 4 do
  if not top[i].Enter then top[i].W := text_GetWidth( Font, top[i].Nick ) + Length(top[i].Nick)*1-1;

  for i := 0 to 4 do
  if top[i].Enter then
  begin
    key_EndReadText( top[i].nick );
    top[i].W := text_GetWidth( Font, top[i].Nick ) + Length(top[i].Nick)*1;
    pr2d_Rect( 320 + top[i].W / 2, 178+i*40, 10, 20, $FFFFFF, 100, PR2D_FILL );
    if Key_Up(K_ENTER) then
    begin
      top[i].Enter := False;
      top[i].Nick := top[i].nick + #0;
    end;
  end;
  DEC( lineAlpha, 5 );

  for i := 0 to 4 do
  if (top[i].Nick = '' + #0) and not top[i].Enter then top[i].Nick := 'Anonymous';
end;

procedure Menu_Paint;
var
i: Integer;
begin
  //pr2d_Rect( 0, 0, 640, 480, $4A94FA, 255, PR2D_FILL );
  //tiles2d_Draw( Back, 0, 0, TilesBack, 255 );

  ssprite2d_Draw( GameLogo, 20, 40, 600, 126, 0, 255 );
  Button_Paint( @BNewGame );
  Button_Paint( @BContinue );
  Button_Paint( @BRecords );
  Button_Paint( @BQuit );
  Button_Paint( @BCredits );
  SmallButton_Paint( @BLevel1 );
  SmallButton_Paint( @BLevel2 );
  SmallButton_Paint( @BLevel3 );
  for i := 0 to 4 do
  begin
    asprite2d_Draw( ButtonSmallTex, 300, 178+i*40, 40, 40, 0, 1, Round(ScoresState.Alpha/2) );
    text_DrawEx( Font, 320-top[i].w-28, 178+i*40+13, 1, 1, top[i].Nick, Round(ScoresState.Alpha) );
    text_DrawEx( Font, 316, 178+i*40+14, 0.8, 1, U_IntToStr(i+1), Round(ScoresState.Alpha) );
    text_DrawEx( Font, 344, 178+i*40+13, 1, 1, U_IntToStr(top[i].Score), Round(ScoresState.Alpha) );
    if top[i].Enter then pr2d_Rect( 320-25, 178+i*40+8, 2, 25, $FFFFFF, lineAlpha, PR2D_FILL );
  end;
  ssprite2d_Draw( Head, 407, 190, 140, 140, 0, Round(CreditsState.Alpha) );
  for i := 0 to 6 do
  begin
    text_DrawEx( Font, About[i].X, 178+i*20+13*(1+(1-About[i].S)), About[i].S , 1, About[i].Text, Round(CreditsState.Alpha*About[i].S) );
  end;
  //pr2d_Circle( BNewGame.C.cX, BNewGame.C.cY, BNewGame.C.radius, $FF0000 );
  if Paused then text_DrawEx( Font, 290, 156, 1, 1, 'Pause', 255, $FFFFFF );
end;

procedure Top_Process;
var
i: integer;
begin
  Button_Process( @BBack );
  if mouse_Up( M_BLEFT ) then
  begin
    if BBack.Mouse then
    begin
      Scene := sMenu;
      Lose := False;
      for i := 0 to 4 do
      if top[i].Enter then
      begin
        top[i].Enter := False;
        top[i].nick := top[i].nick + #0;
      end
    end;
  end;

  for i := 0 to 4 do
  if top[i].Enter then
  begin
    key_EndReadText( top[i].nick );
    //top[i].W := text_GetWidth( Font, top[i].Nick );
    pr2d_Rect( 320 + top[i].W / 2, 150+i*30, 10, 20, $FFFFFF, 100, PR2D_FILL );
    if Key_Up(K_ENTER) then
    begin
      top[i].Enter := False;
      top[i].nick := top[i].nick + #0;
    end;
  end;
  DEC( lineAlpha, 5 );

  for i := 0 to 4 do
  if (top[i].Nick = '' + #0) and not top[i].Enter then top[i].Nick := 'Anonymous';
end;

procedure Top_Paint;
var
i: Integer;
begin
  pr2d_Rect( 0, 0, 640, 480, $4A94FA, 255, PR2D_FILL );
  if Lose then text_DrawEx( Font, 200, 80, 1, 1, 'You Lose :(', 255, $FFFFFF );
  for i := 0 to 4 do
  begin
    text_Draw( Font, 200, 150+i*30, top[i].Nick+' - '+U_IntToStr(top[i].Score) );
    if top[i].Enter then pr2d_Rect( 200 + top[i].W, 150+i*30-2, 3, 24, $FFFFFF, lineAlpha, PR2D_FILL );
  end;
  Button_Paint( @BBack );
end;

end.

