program Detonator;
uses
  sNail,
  OpenGL,
  Windows,
  NFAFont,
  uGeneral,
  uParticles,
  uMenu;

//{$R *.res}
const
  PACK_NAME = 'data/texpack1.mpx';
var
  texBg: cardinal;

procedure PreloadEng;
begin
  pack_SetPassword('igdc');
  tex_Load(PACK_NAME, 'font.bmp', texFont, false);
  font.Load('data/font.nfa');
  font.SetTexture(texFont);

  gl_SetOrtho;
  gl_ClearScreen(true);
  gl_SetBlend(BLEND_SUB);
  font.Render(10, 10, 'Loading... Please wait.');
end;

procedure InitEng;
var
  i: byte;
begin
  soundEnable := snd_Init;
  if soundEnable then
  begin
    sndBombActive := snd_Load(nil, 'data/sounds/bombactivate.wav');
    sndNewFiled := snd_Load(nil, 'data/sounds/newfield.wav');
    sndExplosion := snd_Load(nil, 'data/sounds/expl.wav');
    sndClick := snd_Load(nil, 'data/sounds/click.wav');
    sndOpen := snd_Load(nil, 'data/sounds/open.wav');
    sndError := snd_Load(nil, 'data/sounds/error.wav');
  end;

  tex_Load(PACK_NAME, 'cells_open.png', texCellsOpen, true);
  tex_Load(PACK_NAME, 'cells_close.png', texCellsClose, true);
  tex_Load(PACK_NAME, 'flag.png', texFlag, true);
  tex_load(PACK_NAME, 'bg.png', texBg, true);
  tex_Load(PACK_NAME, 'timer.png', texTimer, false);
  tex_Load(PACK_NAME, 'C4.png', texC4, false);
  tex_Load(PACK_NAME, 'boom.tga', texPart, false);
  tex_Load(PACK_NAME, 'logo.png', texLogo, false);

  for i := 0 to High(lines) do
    lines[i].Init;

  menu.Init;  
  minesField.Init;
end;

procedure UpdateEng;
var
  i: byte;
begin
  if not isMenu then
    minesField.Update
  else
    menu.Update;

  for i:=0 to High(lines) do
    lines[i].Update;
end;

procedure RenderEng;
var
  i: byte;
begin
  gl_SetOrtho;
  gl_SetColor($ffffff);

  gl_TexEnable(texBg);
  glPushMatrix;
    gl_RenderTex(0,0, gl_GetResX, gl_GetResY, 0);
  glPopMatrix;
  gl_TexDisable;

  for i:=0 to High(lines) do
    lines[i].Render;

  if not isMenu then
    minesField.Render
  else
    menu.Render;

 // font.Render(10, gl_GetResY - 20, 'FPS: ' + Int2Str(gl_GetFPS));
end;

procedure FreeEng;
begin
  minesField.Free;
end;

begin
  randomize;
  snail_SetName('Detonator');
  snail_SetTimer(30);

  snail_RegProc(PROC_PRELOAD, @PreloadEng);
  snail_RegProc(PROC_INIT, @InitEng);
  snail_RegProc(PROC_UPDATE, @UpdateEng);
  snail_RegProc(PROC_RENDER, @RenderEng);
  snail_RegProc(PROC_FREE, @FreeEng);

  tex_Params(FILTER_BILINEAR);
  snail_Run(800, 600, 32, 75, 0, false, false, true);
end.
