unit win;
interface

procedure Win_Draw;
procedure Win_Work;
procedure Win_Init;

implementation
uses
  LTe_friend,
  Omega, m_materials,  g_materials, PMain, Setup;

type
  tZExpl = class
    P,
    M : TM2DRealPoint;
    L : single;
    Color : TLXGL_Color;
    procedure Add;
    procedure Move;
  end;
var
  ZExpl : TZExpl;

procedure Win_Draw;
begin
  with ZExpl do
  begin
    Color_Use(Color);
    Draw2D_Sprite(lm_Expl, P.X, P.Y, 64, 64, 0, 1);
  end;

  Expl_Draw(1);
  Color_Clear;

  Text_Draw(FontA1, (WinW - Omega.Text_GetWidth
           (FontA1, ',   !', 1.5)) / 2, (WinH - 128)/ 2,
                      ',   !', 1.5);

  Text_Draw(FontA1, (WinW - Omega.Text_GetWidth
           (FontA1, ' Enter', 0.9)) / 2, (WinH - 64),
                    ' Enter!', 0.9);
end;

procedure Win_Work;
begin
  Expl_Work;
  ZExpl.Move;

  if (Key_Press(k_Escape))
  or (Key_Press(k_Space)) 
  or (Key_Press(k_Enter)) then
    TofG := 2;
end;
var
  AColor : array[0..5] of Integer = ($FF, $FF00, $FF0000, $FFFF00, $FF00FF, $FFFF);

procedure tZExpl.Add;
var
  R, MR : SIngle;
begin
  P := Set2DRealPoint( WinW / 2, WinH );
  R := -45 - random(90);
  MR  := pi*(R)/180;
  M := Set2DRealPoint(cos(MR) * 5, sin(MR) * 5);
  L := 22 + random(15);
  Color := Int2RGB(AColor[Random(6)]);
end;

procedure tZExpl.Move;
begin
  if L > 1 then
  begin
    L := L - 0.5;
    P.X := P.X + M.X;
    P.Y := P.Y + M.Y;
  end
  else
  begin
    Expl_Add(lm_Expl, P.X, P.Y, random(128) + 128, Color, 1);
    Add;
  end;
end;

procedure Win_Init;
begin
  ZExpl := tZExpl.Create;
  ZExpl.Add;
end;

end.
