unit GSound;

interface
uses
  Bass, LexUtils, Omega, Setup;

procedure InitGS;
const
  sound_Flash     = 1;
  sound_howl      = 2;
  sound_Not       = 3;
  sound_OK        = 4;
  sound_Boom      = 5;
  sound_Exp       = 6;
  sound_Red       = 7;
  sound_Green     = 8;
  sound_Blue      = 9;
  sound_Cast      = 10;
  sound_Trea      = 11;
procedure PlaySound( I : Byte);
procedure TrackPlay;
procedure TrackMidiPlay;
procedure Kill;

implementation
const
  MofSound = 11;
  MofMidi  = 7;
var
  NSound : array[1..MofSound ] of string = ('Flash.OGG', 'howl.MP3', 'Not.OGG', 'OK.OGG',
                                            'Boom.OGG', 'Exp.OGG', 'Red.OGG', 'Green.OGG',
                                            'Blue.OGG', 'Cast.OGG', 'Trea.OGG');
  S_Gn   : array[1..MofSound ] of Cardinal;
  S_Intro,
  S_MZT  : Cardinal;
  WSD    : Boolean;

procedure LoadSounds;
var
  I : integer;
begin
  S_Intro := BASS_StreamCreateFile(False, PChar('Data\Sound\Intro.OGG'), 0, 0, 0 );
  for I := 1 to MofSound do
    S_Gn[I] := BASS_StreamCreateFile(False, PChar('Data\Sound\' + NSound[I]), 0, 0, 0);
  PlaySound(sound_howl);
end;

procedure TrackPlay;
begin
  if (WSD) and (Setup.Sound > 0) then
  begin
    BASS_ChannelPlay(S_Intro, TRUE);
  end;
end;

procedure TrackMidiPlay;
begin
  if (WSD) and (Setup.Sound > 0) then
  begin
    Media_Play( PChar('Data\Midi\' + Int2S(Random(MofMidi) + 1)+ '.MID'), True );
  end;
end;

procedure InitGS;
begin
  if BASS_Init(-1, 44100, 0, 0, nil) then
  begin
    WSD:=true;
    Snd_Init;
    LoadSounds;
  end
  else
    WSD:=false;
end;

procedure PlaySound;
begin
  if (WSD) and (Setup.Sound > 0) then
  begin
    BASS_ChannelPlay(S_Gn[I], TRUE);
  end;
end;

procedure Kill;
begin

  Media_Stop;
end;

end.
