unit g_effect;

interface

type
  TDElement = record
    Enabled            : Boolean;
    Tp                 : Byte;                // 
    Size, ppSize,                             // , 
    mdX, mdY,                                 // 
    pcX, pcY,                                 // 
    R, ppR,                                   // 
    ppAlpha,
    Alpha              : Single;              // 
  end;

  TEffect = class
    Element : array of TDElement;
    function Add : Integer;
  end;

  TDTile  = class(TEffect)
    procedure Work;
  end;

  TSEffect = class(TEffect)
    function Work(I : Integer) : Boolean;
  end;


implementation
uses
  LexUtils,
  LTe_friend;

function TSEffect.Work;
begin
  Result := False;
  with Element[I] do
  if Enabled then
  begin
    App(Size, ppSize);
    if ((ppAlpha < 0) and (Alpha > 0.05))
    or ((ppAlpha > 0) and (Alpha < 0.95)) then
      App(Alpha, ppAlpha)
    else
    begin
      Enabled := False;
      Result  := True;
    end;
  end;
end;

function TEffect.Add;
var
  I, J, L : Integer;
begin
  I := - 1;
  L := Length(Element);
  for J:=0 to L-1 do
  if not Element[J].Enabled then
    begin
      I := J;
      Break;
    end;
  if I=-1 then
    begin
      I:=L;
      SetLength(Element, I + 1);
    end;
  Result := I;
end;

procedure TDTile.Work;
var
  I : Integer;
begin
  for I := 0 to Length(Element) - 1  do
  with Element[I] do
  if Enabled then
  begin
    App(pcX, mdX);
    App(pcY, mdY);
    App(mdY, + 0.01);
    App(R, ppR);
    if Alpha > 0.2 then
      App(Alpha, -0.01)
    else
      Enabled := False;
  end;
end;
end.
