unit g_main;

interface
uses
  LTe_friend,
  g_map;

type
  TGame = class
    Map : TMap;                               //  
    Live,
    LiveMax,
    Force,
    ForceMax : Byte;
    procedure Level;
    procedure New;
    procedure Work;
    procedure Draw;
    procedure Bomb;
    procedure RedBotle;
    procedure BlueBotle;
    procedure Saph;
  end;

var
  Game   : TGame;
  Old_Mouse,
  Camera : TM2DRealPoint;
  MinGL : Boolean;

implementation
uses
  Omega,
  OpenGL,
  LexUtils,
  g_size,
  m_materials,
  g_materials,
  cursor,
  g_level,
  g_opt,
  PMain,
  Setup,
  GSound;

procedure TGame.Level;
begin
  TrackMidiPlay;
  Map.Init( LevelS[ LevelN, 1] );
  Camera := Set2DRealPoint(0, 0);
  g_size_Init;
  Live  := LiveMax;
  Force := ForceMax;
  Wimd  := ws_Open;
end;

procedure TGame.New;
begin
  if Map =  nil then
    Map := TMap.Create;
  LiveMax  := 1;
  ForceMax := 1;
  Level;
end;

procedure TGame.Work;
  procedure Mouse_Move;
  var
    nmX, nmY : single;
  begin
    if Omega.Mouse_Down(M_RBUTTON) then
    begin
      nmX := (Mouse_X - Old_Mouse.X) / 2;
      nmY := (Mouse_Y - Old_Mouse.Y) / 2;

      if  (nmX < 0)
      and (Camera.X + nmX >   Map.StX - S_TD) then
        App(Camera.X,  nmX) ;
      if  (nmX > 0)
      and (Camera.X + nmX < - Map.StX + S_TD) then
        App(Camera.X,  nmX) ;
      if  (nmY < 0)
      and (Camera.Y + nmY >   Map.StY - S_TD) then
        App(Camera.Y,  nmY) ;
      if  (nmY > 0)
      and (Camera.Y + nmY < - Map.StY + S_TD + 64) then
        App(Camera.Y,  nmY) ;
     end;

    if  (Omega.Mouse_WheelUp)
    and (S_T < 128) then
      g_size_Set(S_T + 2);
    if Omega.Mouse_WheelDown
    and (S_T > 16) then
      g_size_Set(S_T - 2);
    Old_Mouse := Set2DRealPoint(Mouse_X, Mouse_Y);
  end;

  procedure Came_Move;
  begin

    if (Map.StX > S_T/2)
    and (Abs(Camera.X) > 1) then
    begin
      if Camera.X > 0 then
        App(Camera.X, - 2)
      else
        App(Camera.X, + 2);
    end;

    if (Map.StY > S_T/2)
    and (Abs(Camera.Y) > 1) then
    begin
      if Camera.Y > 0 then
        App(Camera.Y, - 2)
      else
        App(Camera.Y, + 2);
     end;

  end;
begin
  Map.Update;

  // 
  Mouse_Move;
  Came_Move;
  //   
  if Mouse_Y < WinH - 64 then
  begin
    MinGL := False;
    Map.Work(Mouse_X + Camera.X,
             Mouse_Y + Camera.Y, Mouse_Press(M_LBUTTON), Wimd)
  end
  else
  begin
    if  (Mouse_X > WinW/2 - 20)
    and (Mouse_X < WinW/2 + 20)
    and (Mouse_Y > WinH - 52)
    and (Mouse_Y < WinH + 8 )
    then
      MinGL := True
    else
      MinGL := False;

    if  (Mouse_Press(M_LBUTTON))
    and (Force > 0)
    and (MinGL) then
    begin
      if Wimd <> ws_Cast then
        Wimd := ws_Cast
      else
        Wimd := ws_Open;
    end;
  end;
  // 
  Expl_Work;

  if Key_Press(k_Escape) then
    TofG := 2;
end;

procedure TGame.Bomb;
begin
  Inc(Opt.MofE_ME[1, 2]);
  if Live > 0 then
    Dec(Live)
  else
  begin
    PlaySound(sound_howl);
    Level;
  end;
end;

procedure TGame.RedBotle;
begin
  
  if Live < LiveMax then
  Inc(Live);
end;

procedure TGame.BlueBotle;
begin
  if Force < ForceMax then
  Inc(Force);
end;

procedure TGame.Saph;
begin
  Inc(Opt.MofE_ME[2, 2]);
  if Opt.MofE_ME[2, 2] = Opt.MofE_ME[2, 1] then
  begin
    playsound(sound_Trea);
    if LevelN < MofLevel then
    begin
      Inc(LevelN);
      Level;
    end
    else
      TofG := 4;
  end;
end;

procedure TGame.Draw;
var
  I : Integer;
begin
  Map.Draw;
  Camera_Set(Camera);
  Expl_Draw(0);

  STile_Draw(m_top, 0, WinH - 64, 128, 64, WinW div 128 + 1, 1);

  for I := 1 to Live do
    Draw2D_Sprite(lm_Red, I*34, WinH - 28, 32, 16);
  for I := Live + 1 to LiveMax do
    Draw2D_Sprite(lm_nRed, I*34, WinH - 28, 32, 16);

  for I := 1 to Force do
    Draw2D_Sprite(lm_Blue, WinW - I*34,  WinH - 28, 32, 16);
  for I := Force + 1 to ForceMax do
    Draw2D_Sprite(lm_nBlue, WinW - I*34, WinH - 28, 32, 16);

  Draw2D_Sprite(lm_t_el[1], WinW/2 - 108, WinH - 28, 32, 32, 0, 0, 0.9);
  Omega.Text_Draw(FontA1, WinW/2 - 90, WinH - 40,
                  PChar(Int2S(Opt.MofE_ME[1,2]) +'/' + Int2S(Opt.MofE_ME[1,1])), 1, 0, 200);

  if Wimd = ws_cast then
    Draw2D_Sprite(lm_gla, WinW/2 , WinH - 27, 48, 48)
  else
  if MinGL then
    Draw2D_Sprite(lm_gld, WinW/2 , WinH - 27, 48, 48)
  else
    Draw2D_Sprite(lm_gl, WinW/2 , WinH - 27, 48, 48);

  Draw2D_Sprite(lm_t_el[2], WinW/2 + 64, WinH - 28, 32, 32, 0, 0, 0.9);
  Omega.Text_Draw(FontA1, WinW/2 + 82, WinH - 40,
                  PChar(Int2S(Opt.MofE_ME[2,2]) +'/' + Int2S(Opt.MofE_ME[2,1])), 1, 0, 200);

end;

end.
